<?php
include "common/main.php";

if(isset($_SERVER["PATH_INFO"])){
    if($_SERVER["PATH_INFO"] === "/"){
        header("Location: /");
        exit(0);
    }
    
    $path_info = substr(str_replace("..","",preg_replace("/[^0-9\/]/","",$_SERVER["PATH_INFO"])),1);
    
    $kihon_path = "entries/".$path_info;
    
    $config_path = $kihon_path."_config.ini";
    $content_path = $kihon_path."_content.html";
    $comment_path = $kihon_path."_comment.ini";
    
    if(file_exists($config_path) && file_exists($content_path) && file_exists($comment_path)){
        $config = parse_ini_file($config_path);
        if(!$config["public"]){
            header("HTTP/1.1 404 Not Found");
            include "err/e404.php";
            exit(0);
        }
        $comment = parse_ini_file($comment_path);
    }else{
        header("HTTP/1.1 404 Not Found");
        include "err/e404.php";
        exit(0);
    }
}else{
    header("Location: /");
    exit(0);
}

$date = substr($config["created_date"],0,strpos($config["created_date"]," "));
$date_path = explode("/",$date);
?><!DOCTYPE html>
<html>
    <head>
<?php  head_include();

print "<title>".$config["title"]." | ".$setting["title"]."</title>\n";
print $setting["head_code"]."\n";
?>
    </head>
    <body>
<?php header_include(); ?>
                <div id="content">
<?php
$time_s = time();
$kyo = date("Y/n/j",$time_s);
$kino = date("Y/n/j",$time_s - 86400);


$notice = parse_ini_file("entries/notice.ini");

if($notice["important"]){
    print "<span style='color: #ff0000; font-weight: bold;'>重要なお知らせ</span>";
    print "<div class='comment' style='border-color: #ff0000; background-color: #ffeeee;'>\n";
    print $notice["text"]."<br>\n";
    print "<span class='supplement'>".$notice["modified_date"]."</span>\n";
    print "</div>\n";
}


if(strlen($config["before_page"]) != 0){
    $before_config = parse_ini_file("entries/".$config["before_page"]."_config.ini");
    if($before_config["public"]){
        $before_link = "<a href='".$dir_path."blog.php/".$config["before_page"]."'style='float: left;' title='".$before_config["title"]."'>&lt;&lt;".mb_substr($before_config["title"],0,16)."...</a>";
    }else{
        $before_link = "";
    }
}else{
    $before_link = "";
}

if(strlen($config["after_page"]) != 0){
    $after_config = parse_ini_file("entries/".$config["after_page"]."_config.ini");
    if($after_config["public"]){
        $after_link = "<a href='".$dir_path."blog.php/".$config["after_page"]."'style='float: right;' title='".$after_config["title"]."'>".mb_substr($after_config["title"],0,16)."...&gt;&gt</a>";
    }else{
        $after_link = "";
    }
}else{
    $after_link = "";
}

$zengo = $before_link.$after_link."<br style='clear: both;'>\n";

$ad = parse_ini_file("config/ad.ini");


if(!$config["static_page"]){
    print $ad["top_ad"];
    
    print "\n<a href='".$dir_path."archive/'>目次</a> &gt; <a href='".$dir_path."archive/index.php/".$date_path[0]."'>".$date_path[0]."年</a> &gt; <a href='".$dir_path."archive/index.php/".$date_path[0]."/".$date_path[1]."'>".$date_path[1]."月</a> &gt; <a href='".$dir_path."archive/index.php/".$date_path[0]."/".$date_path[1]."/".$date_path[2]."'>".$date_path[2]."日</a> &gt;<br>\n";
    
    for($c_cnt_1 = 1; isset($config["category"][$c_cnt_1]); $c_cnt_1++){
        $category_bunkatsu = explode("/",$config["category"][$c_cnt_1]);
        
        if($c_cnt_1 == 1){
            $category_top = $category_bunkatsu[0];
        }
        
        print "カテゴリー： <img src='".$dir_path."style/category_icon.png' alt=''>";
        
        for($c_cnt_2 = 0; isset($category_bunkatsu[$c_cnt_2]); $c_cnt_2++){
            if($c_cnt_2 == 0){
                $category_url = urlencode($category_bunkatsu[0]);
            }else{
                $category_url = $category_url."/".urlencode($category_bunkatsu[$c_cnt_2]);
                print " / ";
            }
            
            print "<a href='".$dir_path."archive/category.php/".$category_url."' style='font-size: x-large;'> ".$category_bunkatsu[$c_cnt_2]."</a>";
        }
    print "<br>";
    }
}
print "<button onclick='location.href = \"".$dir_path."owner/edit.php?page=".urlencode($path_info)."\"' class='admin_button'>管理者ログイン</button>";

if(!$mobile && !$config["static_page"]){
    print $zengo;
}
    
print "<h1>".$config["title"]."</h1>\n";

if(!$config["static_page"]){
    print "<div style='color: #999999; font-size: smaller; line-height: 120%;'>作成日時： ".$config["created_date"]."<br>\n最終更新： ".$config["modified_date"]."</div><br>\n";
}

readfile($content_path);
print "<br><br>\n";

if(!$config["static_page"]){
    print $zengo;
    print "<br>\n";
    
    print $ad["bottom_ad"];
    print "<br>\n";

    
    if(strlen($config["tag"]) >= 1){
        $tag = explode(" ",$config["tag"]);
        $tag_kosu = count($tag);
        print "<div id='tag'>この記事のタグ：<br>\n";
        for($tag_c = 0; $tag_c < $tag_kosu; $tag_c++){
            print "<a href='".$dir_path."archive/tag.php/".urlencode($tag[$tag_c])."'>".$tag[$tag_c]."</a>";
        }
        print "\n</div>\n";
    }

    
    print "\n<h3>".$category_top."の新しい記事</h3>";
    $c_rireki = parse_ini_file("entries/recent_articles_categories/".mb_convert_encoding($category_top,$sys_conf["file_name_code"],"auto").".ini");
    
    $c_r_kosu = count($c_rireki["title"]);
    for($c_r_cnt = 1; $c_r_cnt <= $c_r_kosu; $c_r_cnt++){
        $rireki_hizuke = explode(" ",$c_rireki["created_date"][$c_r_cnt]);
        print "<a href='".$dir_path."blog.php/".$c_rireki["path"][$c_r_cnt]."' class='small_link'>";
        if($rireki_hizuke[0] === $kyo || $rireki_hizuke[0] === $kino){
            print "<span class='new'>NEW</span> ";
        }
        print$c_rireki["title"][$c_r_cnt]."</a>\n";
    }
}

$comment_ini = parse_ini_file($hongi_root."/config/comment.ini");

if($comment_ini["enable_comment"] >= 1 && $config["enable_comment"] >= 1){
    print "<div id='comment_box'>\n";
    
    print "<h2>この記事へのコメント</h2>\n";
    
    if(isset($comment["author"])){
        $keys = array_keys($comment["approved"],TRUE);
        $keys_kosu = count($comment["approved"]);
        
        $approved_kosu = count($keys);
        $not_approved_kosu = $keys_kosu - $approved_kosu;
        
        if($approved_kosu > 30){
            $cnt = $approved_kosu - 30;
            
            print "コメント数が多いため、最新30件のみを表示しています。<br><br>\n";
            print "<div style='text-align: center'><button type='button' onclick='load_comments(\"".$path_info."\");' style='font-size: x-large;'>全てのコメントを表示</button></div>\n";
        }else{
            $cnt = 0;
        }
        
        for(; $cnt < $approved_kosu; $cnt++){
            if($comment["cap"][$keys[$cnt]] === "admin"){
                print "<div class='comment comment_admin' id='comment_".$keys[$cnt]."'>\n";
            }else{
                print "<div class='comment' id='comment_".$keys[$cnt]."'>\n";
            }
            
            $comment_hizuke = explode(" ",$comment["date"][$keys[$cnt]]);
            if($comment_hizuke[0] === $kyo || $comment_hizuke[0] === $kino){
                print "<span class='new'>NEW</span>";
            }
            print "<h4>".$keys[$cnt].".</h4>\n";
            
            if(strlen($comment["image"][$keys[$cnt]]) >= 1){
                print "<img src='".$dir_path."image/".$comment["image"][$keys[$cnt]]."_300.jpeg' alt=''><br>\n";
            }
            
            print $comment["text"][$keys[$cnt]]."<br>\n";
            
            print "<span class='supplement'>";
            if(!$mobile){
                print "投稿者：";
            }
            print $comment["author"][$keys[$cnt]];
            if(strlen($comment["cap"][$keys[$cnt]]) > 0){
                if($comment["cap"][$keys[$cnt]] === "admin"){
                    print "<b>(管理者)</b>";
                }else{
                    print "<b>(".$comment["cap"][$keys[$cnt]].")</b>";
                }
            }
            if(!$mobile){
                print "　投稿日時：";
            }else{
                print "<br>\n";
            }
            print $comment["date"][$keys[$cnt]]."</span>\n";
            print "</div>\n";
        }
        
        if($not_approved_kosu >= 1){
            print "<br><span style='font-size: x-large;' id='not_approved'>この他に未承認のコメントが<b style='color: #ff0000;'>".$not_approved_kosu."</b>件あります。</span>\n";
        }
        
        if($keys[$cnt - 1] <= 1000){
            $comment_blank_exist = TRUE;
        }else{
            $comment_blank_exist = FALSE;
        }
    }else{
        $comment_blank_exist = TRUE;
    }
    
    print "</div>\n";
    
    if($comment_ini["enable_comment"] == 2 && $config["enable_comment"] == 2 && $comment_blank_exist){
?>
<h3>ここにコメントする</h3>
<?php
print "<form name='comment_form' action='".$dir_path."blog_supplement/comment_post.php' method='post' enctype='multipart/form-data'>";
print "    <input type='hidden' name='page' value='".$path_info."'>";
?>
    <div id="comment_screen">
        <div id="comment_kakunin">
            <div style="float: right; width: 32px; padding-top: 8px; font-size: x-large; color: #999999; cursor: pointer;" onclick="close_kakunin();">×</div>
            <span id="captcha">読み込み中...</span><br>
            <br>
            <span id="button_wrapper" style="display: none;"><button type="button" onclick="comment_submit()" style="padding: 8px 64px; font-size: large;">コメントの確定</button></span>
        </div>
    </div>
    <h4>ハンドルネーム</h4>
    <input type="text" name="author" style="width: 300px;">(省略時は匿名になります)<br>
    トリップを使用する場合は半角「#」の後にキー文字列を続けてください。
    <h4>本文</h4>
    <textarea id="comment_area" class="write_area" name="text"></textarea>
    <h4>アップロードする画像ファイル</h4>
    コメントに画像を添付することができます。<br>
    <input type="hidden" name="MAX_FILE_SIZE" value="8388608"><input type="file" name="up_file" onchange="file_change();" id="up_file">(8MBまで)
    <div id="view"></div>
    <br>
    <button type="button" style="padding: 8px 64px; font-size: large;" onclick="comment_button()">コメントの投稿</button>
</form>
<?php
    }else{
        print "<br><br><b>現在このページでは、新規のコメントは受け付けていません。</b><br>";
    }
}

if(!$config["static_page"] && strlen($ad["end_ad"]) >= 1){
print "<br>\n";
print $ad["end_ad"]."\n";
}
?>
                </div>
<?php
if(!$mobile){
    print "<div id='side'>\n";
    
    if(file_exists("config/authors/".$config["user_id"].".html")){
        print "<h3>著者</h3>\n";
        readfile("config/authors/".$config["user_id"].".html");
    }
    
    if(!$notice["important"] && strlen($notice["text"]) >= 1){
        print "<h3>お知らせ</h3>\n";
        print "<div class='comment'>\n";
        print $notice["text"]."<br>\n";
        print "<span class='supplement'>".$notice["modified_date"]."</span>\n";
        print "</div>\n";
    }
    
    print "<h3>カテゴリー</h3>\n";
    readfile("config/categories.html");
    if(!$config["static_page"]){
        print "<h3>".$date_path[0]."年 ".$date_path[1]."月</h3>\n";
        readfile("entries/".$date_path[0]."/".$date_path[1]."/calendar/main.html");
        print "<br><br>\n";
        
        print $ad["side_ad"];
        
        print "\n<h3>新しい記事</h3>\n";
        
        readfile("entries/recent_articles_side.html");
    
        print "<h3>".$category_top."に関連のタグ</h3>";
        
        print "<div class='tag_cloud'>\n";
        readfile(mb_convert_encoding("entries/tags_categories/".$category_top.".html",$sys_conf["file_name_code"],"auto"));
        print "</div>\n";
    }
    
    print "</div>\n";
}
?>        
<?php footer_include(); ?>
    </body>
</html><!--Powered by Open本紀-->