<?php
include "../common/main.php";

if(isset($_SERVER["PATH_INFO"])){
    if($_SERVER["PATH_INFO"] === "/"){
        header("Location: /");
        exit(0);
    }
    
    $path_info = substr(str_replace("..","",preg_replace("/[^0-9\/]/","",$_SERVER["PATH_INFO"])),1);
    
    $kihon_path = "../entries/".$path_info;
    
    $config_path = $kihon_path."_config.ini";
    $comment_path = $kihon_path."_comment.ini";
    
    if(file_exists($config_path) && file_exists($comment_path)){
        $config = parse_ini_file($config_path);
        if(!$config["public"]){
            header("HTTP/1.1 404 Not Found");
            include "err/e404.php";
            exit(0);
        }
        $comment = parse_ini_file($comment_path);
    }else{
        header("HTTP/1.1 404 Not Found");
        include "../err/e404.php";
        exit(0);
    }
}else{
    header("Location: /");
    exit(0);
}

$time_s = time();
$kyo = date("Y/n/j",$time_s);
$kino = date("Y/n/j",$time_s - 86400);


$comment_ini = parse_ini_file($hongi_root."/config/comment.ini");

if($comment_ini["enable_comment"] >= 1 && $config["enable_comment"] >= 1){
    print "<h2>この記事へのコメント</h2>\n";
    
    if(isset($comment["author"])){
        $keys = array_keys($comment["approved"],TRUE);
        $keys_kosu = count($comment["approved"]);
        
        $approved_kosu = count($keys);
        $not_approved_kosu = $keys_kosu - $approved_kosu;
        
        for($cnt = 0; $cnt < $approved_kosu; $cnt++){
            if($comment["cap"][$keys[$cnt]] === "admin"){
                print "<div class='comment comment_admin' id='comment_".$keys[$cnt]."'>\n";
            }else{
                print "<div class='comment' id='comment_".$keys[$cnt]."'>\n";
            }
            
            $comment_hizuke = explode(" ",$comment["date"][$keys[$cnt]]);
            if($comment_hizuke[0] === $kyo || $comment_hizuke[0] === $kino){
                print "<span class='new'>NEW</span>";
            }
            print "<h4>".$keys[$cnt].".</h4>\n";
            
            if(strlen($comment["image"][$keys[$cnt]]) >= 1){
                print "<img src='".$dir_path."image/".$comment["image"][$keys[$cnt]]."_300.jpeg' alt=''><br>\n";
            }
            
            print $comment["text"][$keys[$cnt]]."<br>\n";
            
            print "<span class='supplement'>";
            if(!$mobile){
                print "投稿者：";
            }
            print $comment["author"][$keys[$cnt]];
            if(strlen($comment["cap"][$keys[$cnt]]) > 0){
                if($comment["cap"][$keys[$cnt]] === "admin"){
                    print "<b>(管理者)</b>";
                }else{
                    print "<b>(".$comment["cap"][$keys[$cnt]].")</b>";
                }
            }
            if(!$mobile){
                print "　投稿日時：";
            }else{
                print "<br>\n";
            }
            print $comment["date"][$keys[$cnt]]."</span>\n";
            print "</div>\n";
        }
        
        if($not_approved_kosu >= 1){
            print "<br><span style='font-size: x-large;' id='not_approved'>この他に未承認のコメントが<b style='color: #ff0000;'>".$not_approved_kosu."</b>件あります。</span>\n";
        }
        
        if($keys[$cnt - 1] <= 1000){
            $comment_blank_exist = TRUE;
        }else{
            $comment_blank_exist = FALSE;
        }
    }else{
        $comment_blank_exist = TRUE;
    }
}