<?php
define("OPEN_HONGI_CAP_ADMIN","admin");

class open_hongi_comments{
    private $comment_ini;
    
    
    function __construct() {
        $this->comment_ini = parse_ini_file(dirname(dirname(__FILE__))."/config/comment.ini");
    }
    
    
    function get_comments($page){
        $comment_path = dirname(dirname(__FILE__))."/entries/".$page."_comment.ini";
        
        return parse_ini_file($comment_path);
    }
            
    
    function save_comments($page,$comments){
        $comment_path = dirname(dirname(__FILE__))."/entries/".$page."_comment.ini";
        
        if(isset($comments["author"])){
            $keys = array_keys($comments["author"]);
        }else{
            $keys = array();
        }
        
        $file_h = fopen($comment_path,"w");
        
        for($cnt = 0; isset($keys[$cnt]); $cnt++){
            fwrite($file_h,"author[".$keys[$cnt]."]=\"".addslashes($comments["author"][$keys[$cnt]])."\"\r\n");
            fwrite($file_h,"id[".$keys[$cnt]."]=\"".$comments["id"][$keys[$cnt]]."\"\r\n");
            fwrite($file_h,"cap[".$keys[$cnt]."]=\"".$comments["cap"][$keys[$cnt]]."\"\r\n");
            if($comments["approved"][$keys[$cnt]]){
                fwrite($file_h,"approved[".$keys[$cnt]."]=true\r\n");
            }else{
                fwrite($file_h,"approved[".$keys[$cnt]."]=false\r\n");
            }
            fwrite($file_h,"text[".$keys[$cnt]."]=\"".addcslashes($comments["text"][$keys[$cnt]],"\\\0\"")."\"\r\n");
            fwrite($file_h,"image[".$keys[$cnt]."]=\"".$comments["image"][$keys[$cnt]]."\"\r\n");
            fwrite($file_h,"date[".$keys[$cnt]."]=\"".$comments["date"][$keys[$cnt]]."\"\r\n");
        }
        
        fclose($file_h);
    }
    
    
    function escape_text($text,$number){
        $text_after = str_replace(array("\r\n","\n","\r"),"",nl2br(htmlspecialchars($text),FALSE));
        while(1){
            if(substr($text_after,-4) === "<br>"){
                $text_after = substr($text_after,0,-4);
            }else{
                break;
            }
        }
        
        $text_offset = 0;
        while(1){
            $dainari_pos = strpos($text_after,"&gt;&gt;",$text_offset);
            
            if($dainari_pos === FALSE){
                break;
            }
            
            $num_mozisu = 0;
            for($num_pos = $dainari_pos + 8;ctype_digit(substr($text_after,$num_pos,1));$num_pos++){
                $num_mozisu++;
            }
            
            if($num_mozisu >= 1){
                $res_num = intval(substr($text_after,$dainari_pos + 8,$num_mozisu));
                if($res_num < $number && $res_num >= 1){
                    $link_html = "<a href='#comment_".$res_num."'>&gt;&gt;".$res_num."</a>";
                    $text_after = substr($text_after,0,$dainari_pos).$link_html.substr($text_after,$dainari_pos + 8 + $num_mozisu);
                    
                    $text_offset = $dainari_pos + strlen($link_html);
                }else{
                    $text_offset = $dainari_pos + 8;
                }
            }else{
                $text_offset = $dainari_pos + 8;
            }
        }
        
        return $text_after;
    }
    
    
    function update_comment_top($ini_str = NULL){
        if($ini_str === NULL){
            $rireki = parse_ini_file(dirname(dirname(__FILE__))."/entries/recent_comments.ini");
        }else{
            $rireki = parse_ini_string($ini_str);
        }
        $rireki_top_naiyo = "";
        $approved_kensu = 0;
        for($cnt = 1; $approved_kensu < 6 && isset($rireki["author"][$cnt]); $cnt++){
            if($rireki["approved"][$cnt]){
                $approved_kensu++;
                
                if(mb_strlen($rireki["text"][$cnt]) > 16){
                    $rireki_top_text = htmlspecialchars(mb_substr(htmlspecialchars_decode($rireki["text"][$cnt]),0,16))."...";
                }else{
                    $rireki_top_text = $rireki["text"][$cnt];
                }
                $rireki_top_naiyo = $rireki_top_naiyo."text[".$approved_kensu."]=\"".addcslashes($rireki_top_text,"\\\0\"")."\"\npage[".$approved_kensu."]=\"".$rireki["page"][$cnt]."\"\nnumber[".$approved_kensu."]=".$rireki["number"][$cnt]."\ndate[".$approved_kensu."]=\"".$rireki["date"][$cnt]."\"\n";
            }
        }
        
        file_put_contents(dirname(dirname(__FILE__))."/entries/comment_top.ini",$rireki_top_naiyo);
    }
    
    
    function save_recent_comments($rireki){
        $rireki_naiyo = "";
        for($cnt = 1; $cnt < 100; $cnt++){
            if(isset($rireki["author"][$cnt])){
                if($rireki["approved"][$cnt]){
                    $approved_naiyo = "true";
                }else{
                    $approved_naiyo = "false";
                }
                
                $rireki_naiyo = $rireki_naiyo."text[".$cnt."]=\"".addcslashes($rireki["text"][$cnt],"\\\0\"")."\"\ntitle[".$cnt."]=\"".$rireki["title"][$cnt]."\"\npage[".$cnt."]=\"".$rireki["page"][$cnt]."\"\nnumber[".$cnt."]=".$rireki["number"][$cnt]."\nauthor[".$cnt."]=\"".$rireki["author"][$cnt]."\"\ndate[".$cnt."]=\"".$rireki["date"][$cnt]."\"\ncap[".$cnt."]=\"".$rireki["cap"][$cnt]."\"\napproved[".$cnt."]=".$approved_naiyo."\nimage[".$cnt."]=\"".$rireki["image"][$cnt]."\"\n";
            }
        }
        
        file_put_contents(dirname(dirname(__FILE__))."/entries/recent_comments.ini",$rireki_naiyo);
        
        $this->update_comment_top($rireki_naiyo);
    }
    
    
    function add_comment($page,$author,$cap = NULL,$image_id,$text,$approved = NULL){
        $page_path = str_replace("..","",str_replace("\0","",$page));
        
        $config = parse_ini_file(dirname(dirname(__FILE__))."/entries/".$page_path."_config.ini");
        $comment_path = dirname(dirname(__FILE__))."/entries/".$page_path."_comment.ini";
        
        if($config["enable_comment"] != 2 || $this->comment_ini["enable_comment"] != 2){
            print "指定されたページヘのコメントの書き込みは停止されています。";
            return FALSE;
        }
        
        $comment = $this->get_comments($page_path);
        if(isset($comment["author"])){
            $keys = array_keys($comment["author"]);
            $number = $keys[count($keys) - 1] + 1;
        }else{
            $number = 1;
        }
        
        if($number > 1024){
            print "指定されたページにはこれ以上書き込めません。";
            return FALSE;
        }
        
        $igeta_pos = strpos($author,"#");
        if($igeta_pos !== FALSE){
            $cap_naiyo = substr(base64_encode(sha1(substr($author,$igeta_pos + 1),true)),0,12);
            $author = substr($author,0,$igeta_pos);
        }else{
            $cap_naiyo = "";
        }
        
        if(strlen($author) == 0){
            $author = "匿名";
        }else{
            $author = addslashes(strip_tags($author));
        }
        
        if($cap !== NULL){
            $cap_naiyo = $cap;
        }
        
        $text_after = $this->escape_text($text,$number);
        
        $yobi_list = array("日","月","火","水","木","金","土");
        $date_time = date("Y/n/j")." (".$yobi_list[intval(date("w"))].") ".date("A g:i");
        
        if($cap_naiyo === "admin" || $this->comment_ini["auto_approval"] || $approved === TRUE){
            $approved_naiyo = "true";
        }else{
            $approved_naiyo = "false";
        }
        
        $c_text = strip_tags($text_after);
        if(mb_strlen($c_text) > 64){
            $c_saisho = htmlspecialchars(mb_substr(htmlspecialchars_decode($c_text),0,64))."...";
        }else{
            $c_saisho = $c_text;
        }
        
        $rireki = parse_ini_file("../entries/recent_comments.ini");
        
        $rireki_naiyo = "text[1]=\"".addcslashes($c_saisho,"\\\0\"")."\"\ntitle[1]=\"".$config["title"]."\"\npage[1]=\"".$page_path."\"\nnumber[1]=".$number."\nauthor[1]=\"".$author."\"\nimage[1]=\"".$image_id."\"\ndate[1]=\"".$date_time."\"\ncap[1]=\"".$cap_naiyo."\"\napproved[1]=".$approved_naiyo."\n";
        
        if(!empty($rireki)){
            for($rireki_c = 1; $rireki_c < 100; $rireki_c++){
                if(isset($rireki["author"][$rireki_c])){
                    if($rireki["approved"][$rireki_c]){
                        $rireki_approved_naiyo = "true";
                    }else{
                        $rireki_approved_naiyo = "false";
                    }
                    
                    $rireki_naiyo = $rireki_naiyo."text[".($rireki_c + 1)."]=\"".addcslashes($rireki["text"][$rireki_c],"\\\0\"")."\"\ntitle[".($rireki_c + 1)."]=\"".$rireki["title"][$rireki_c]."\"\npage[".($rireki_c + 1)."]=\"".$rireki["page"][$rireki_c]."\"\nnumber[".($rireki_c + 1)."]=".$rireki["number"][$rireki_c]."\nauthor[".($rireki_c + 1)."]=\"".$rireki["author"][$rireki_c]."\"\ndate[".($rireki_c + 1)."]=\"".$rireki["date"][$rireki_c]."\"\ncap[".($rireki_c + 1)."]=\"".$rireki["cap"][$rireki_c]."\"\napproved[".($rireki_c + 1)."]=".$rireki_approved_naiyo."\nimage[".($rireki_c + 1)."]=\"".$rireki["image"][$rireki_c]."\"\n";
                }
            }
        }
        
        file_put_contents(dirname(dirname(__FILE__))."/entries/recent_comments.ini",$rireki_naiyo);
        
        if($approved_naiyo === "true"){
            $this->update_comment_top($rireki_naiyo);
        }
        
        $file_h = fopen($comment_path,"a");
            
        fwrite($file_h,"author[".$number."]=\"".$author."\"\r\n");
        fwrite($file_h,"id[".$number."]=\"\"\r\n");
        fwrite($file_h,"cap[".$number."]=\"".$cap_naiyo."\"\r\n");
        fwrite($file_h,"approved[".$number."]=".$approved_naiyo."\r\n");
        fwrite($file_h,"text[".$number."]=\"".addcslashes($text_after,"\\\0\"")."\"\r\n");
        fwrite($file_h,"image[".$number."]=\"".$image_id."\"\r\n");
        fwrite($file_h,"date[".$number."]=\"".$date_time."\"\r\n");
        
        fclose($file_h);
        
        return $number;
    }
    
    
    function update_comment($page,$number,$author,$cap,$image_id,$text,$approved){
        $comments = $this->get_comments($page);
        
        $number = intval($number);
        
        $comments["author"][$number] = $author;
        $comments["cap"][$number] = $cap;
        $comments["approved"][$number] = $approved;
        $text = $this->escape_text($text,$number);
        $comments["text"][$number] = $text;
        $comments["image"][$number] = $image_id;
        
        $this->save_comments($page,$comments);
        
        $rireki = parse_ini_file("../entries/recent_comments.ini");
        if(!empty($rireki)){
            $c_text = strip_tags($text);
            if(mb_strlen($c_text) > 64){
                $c_saisho = htmlspecialchars(mb_substr(htmlspecialchars_decode($c_text),0,64))."...";
            }else{
                $c_saisho = $c_text;
            }
            
            $keys = array_keys($rireki["page"],$page);
            for($cnt = 0; isset($keys[$cnt]); $cnt++){
                if($rireki["number"][$keys[$cnt]] == $number){
                    $rireki["author"][$keys[$cnt]] = $author;
                    $rireki["cap"][$keys[$cnt]] = $cap;
                    $rireki["approved"][$keys[$cnt]] = $approved;
                    $rireki["text"][$keys[$cnt]] = $c_saisho;
                    $rireki["image"][$keys[$cnt]] = $image_id;
                    
                    $this->save_recent_comments($rireki);
                    break;
                }
            }
        }
    }
    
    
    function delete_comment($page,$number){
        $comments = $this->get_comments($page);
        
        $number = intval($number);
        
        unset($comments["author"][$number]);
        unset($comments["id"][$number]);
        unset($comments["cap"][$number]);
        unset($comments["approved"][$number]);
        unset($comments["text"][$number]);
        unset($comments["image"][$number]);
        unset($comments["date"][$number]);
        
        $this->save_comments($page,$comments);
        
        $rireki = parse_ini_file("../entries/recent_comments.ini");
        if(!empty($rireki)){
            $keys = array_keys($rireki["page"],$page);
            for($cnt = 0; isset($keys[$cnt]); $cnt++){
                if($rireki["number"][$keys[$cnt]] == $number){
                    unset($rireki["text"][$keys[$cnt]]);
                    $rireki["text"] = array_values($rireki["text"]);
                    array_unshift($rireki["text"],null);
                    unset($rireki["title"][$keys[$cnt]]);
                    $rireki["title"] = array_values($rireki["title"]);
                    array_unshift($rireki["title"],null);
                    unset($rireki["page"][$keys[$cnt]]);
                    $rireki["page"] = array_values($rireki["page"]);
                    array_unshift($rireki["page"],null);
                    unset($rireki["number"][$keys[$cnt]]);
                    $rireki["number"] = array_values($rireki["number"]);
                    array_unshift($rireki["number"],null);
                    unset($rireki["author"][$keys[$cnt]]);
                    $rireki["author"] = array_values($rireki["author"]);
                    array_unshift($rireki["author"],null);
                    unset($rireki["date"][$keys[$cnt]]);
                    $rireki["date"] = array_values($rireki["date"]);
                    array_unshift($rireki["date"],null);
                    unset($rireki["cap"][$keys[$cnt]]);
                    $rireki["cap"] = array_values($rireki["cap"]);
                    array_unshift($rireki["cap"],null);
                    unset($rireki["approved"][$keys[$cnt]]);
                    $rireki["approved"] = array_values($rireki["approved"]);
                    array_unshift($rireki["approved"],null);
                    unset($rireki["image"][$keys[$cnt]]);
                    $rireki["image"] = array_values($rireki["image"]);
                    array_unshift($rireki["image"],null);
                    
                    $this->save_recent_comments($rireki);
                    break;
                }
            }
        }
    }
}
?>