<?php
class open_hongi_db{
    private $sys_conf;
    private $setting;
    private $dir_path;
    private $db_obj = array();
    
    function __construct(){
        $this->sys_conf = parse_ini_file(dirname(dirname(__FILE__))."/config/sys_conf.ini");
        $this->setting = parse_ini_file(dirname(dirname(__FILE__))."/config/setting.ini");
        
        $this->dir_path = str_replace("\\","/",substr(dirname(dirname(__FILE__)),strlen($_SERVER["DOCUMENT_ROOT"])))."/";
        
        $this->db_obj = new SQLite3(dirname(dirname(__FILE__))."/entries/main.db");
    }
    
    function setup(){
        $sqlite_r1 = $this->db_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'open_hongi_articles'");
        if($sqlite_r1 == FALSE){
            print "テーブルの確認に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        $q_kekka = $sqlite_r1->fetchArray(SQLITE3_ASSOC);
        if(!$q_kekka){
            $sqlite_r1_2 = $this->db_obj->query("CREATE TABLE `open_hongi_articles`(`path` TEXT NOT NULL PRIMARY KEY, `title` TEXT, `user_id` TEXT, `created_date` TEXT, `modified_date` TEXT, `main_image` TEXT, `public` INTEGER, `static_page` INTEGER)");
            if($sqlite_r1_2 == FALSE){
                print "テーブル open_hongi_articles の作成に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $sqlite_r1_3 = $this->db_obj->query("CREATE INDEX `idx_1` ON `open_hongi_articles`(`user_id`,`created_date`)");
            if($sqlite_r1_3 == FALSE){
                print "テーブル open_hongi_articles のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $sqlite_r1_4 = $this->db_obj->query("CREATE INDEX `idx_2` ON `open_hongi_articles`(`created_date`)");
            if($sqlite_r1_4 == FALSE){
                print "テーブル open_hongi_articles のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $sqlite_r1_5 = $this->db_obj->query("CREATE INDEX `idx_3` ON `open_hongi_articles`(`modified_date`)");
            if($sqlite_r1_5 == FALSE){
                print "テーブル open_hongi_articles のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            print "テーブルopen_hongi_articlesを作成しました。<br>";
        }else{
            print "テーブルopen_hongi_articlesは作成済みです。<br>";
        }
        
        $sqlite_r2 = $this->db_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'open_hongi_categories'");
        if($sqlite_r2 == FALSE){
            print "テーブルの確認に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        $q_kekka = $sqlite_r2->fetchArray(SQLITE3_ASSOC);
        if(!$q_kekka){
            $sqlite_r2_2 = $this->db_obj->query("CREATE TABLE `open_hongi_categories`(`category` TEXT NOT NULL, `path` TEXT NOT NULL, PRIMARY KEY(`category`,`path`))");
            if($sqlite_r2_2 == FALSE){
                print "テーブル open_hongi_categories の作成に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $sqlite_r2_3 = $this->db_obj->query("CREATE INDEX `idx_4` ON `open_hongi_categories`(`path`,`category`)");
            if($sqlite_r2_3 == FALSE){
                print "テーブル open_hongi_categories のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            print "テーブルopen_hongi_categoriesを作成しました。<br>";
        }else{
            print "テーブルopen_hongi_categoriesは作成済みです。<br>";
        }
        
        $sqlite_r3 = $this->db_obj->query("SELECT `name` FROM `sqlite_master` WHERE `type` = 'table' AND `name` = 'open_hongi_tags'");
        if($sqlite_r3 == FALSE){
            print "テーブルの確認に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        $q_kekka = $sqlite_r3->fetchArray(SQLITE3_ASSOC);
        if(!$q_kekka){
            $sqlite_r3_2 = $this->db_obj->query("CREATE TABLE `open_hongi_tags`(`tag` TEXT NOT NULL, `path` TEXT NOT NULL, PRIMARY KEY(`tag`,`path`))");
            if($sqlite_r3_2 == FALSE){
                print "テーブル open_hongi_tags の作成に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $sqlite_r3_3 = $this->db_obj->query("CREATE INDEX `idx_5` ON `open_hongi_tags`(`path`,`tag`)");
            if($sqlite_r3_3 == FALSE){
                print "テーブル open_hongi_tags のインデックスの作成に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            print "テーブルopen_hongi_tagsを作成しました。<br>";
        }else{
            print "テーブルopen_hongi_tagsは作成済みです。<br>";
        }
    }
    
    function add_page($path,$title,$user_id,$created_date,$modified_date,$main_image,$public,$static_page,$category,$tags){
        if($public){
            $public = 1;
        }else{
            $public = 0;
        }
        
        if($static_page){
            $static_page = 1;
        }else{
            $static_page = 0;
        }
        
        $sqlite_r1 = $this->db_obj->query("INSERT INTO `open_hongi_articles`(`path`, `title`, `user_id`, `created_date`, `modified_date`, `main_image`, `public`, `static_page`) values ('".$this->db_obj->escapeString($path)."','".$this->db_obj->escapeString($title)."','".$this->db_obj->escapeString($user_id)."','".$this->db_obj->escapeString($created_date)."','".$this->db_obj->escapeString($modified_date)."','".$this->db_obj->escapeString($main_image)."',".$public.",".$static_page.")");
        if($sqlite_r1 == FALSE){
            print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        if(!$static_page){
            $categories = array();
            
            for($cnt = 0; isset($category[$cnt]); $cnt++){
                $category_bunkatsu = explode("/",$category[$cnt]);
                
                for($cnt_2 = 1; isset($category_bunkatsu[$cnt_2]); $cnt_2++){
                    $category_bunkatsu[$cnt_2] = $category_bunkatsu[$cnt_2 - 1]."/".$category_bunkatsu[$cnt_2];
                }
                
                $categories = array_merge($categories,$category_bunkatsu);
            }
            
            $categories = array_values(array_unique($categories));
            
            $category_kosu = count($categories);
            for($category_c = 0; $category_c < $category_kosu; $category_c++){
                $sqlite_r2 = $this->db_obj->query("INSERT INTO `open_hongi_categories`(`category`,`path`) VALUES ('".$this->db_obj->escapeString($categories[$category_c])."','".$this->db_obj->escapeString($path)."')");
                if ($sqlite_r2 == FALSE){
                    print "SQLコード2の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                    return FALSE;
                }
            }
            
            if(strlen($tags) >= 1){
                $tag_list = explode(" ",$tags);
                $tag_kosu = count($tag_list);
                for($tag_c = 0; $tag_c < $tag_kosu; $tag_c++){
                    $sqlite_r3 = $this->db_obj->query("INSERT INTO `open_hongi_tags`(`tag`,`path`) VALUES ('".$this->db_obj->escapeString($tag_list[$tag_c])."','".$this->db_obj->escapeString($path)."')");
                    if ($sqlite_r3 == FALSE){
                        print "SQLコード3の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                        return FALSE;
                    }
                }
            }
        }
    }
    
    function update_page($path,$title,$user_id,$created_date,$modified_date,$main_image,$public,$static_page,$category,$tags){
        if($public){
            $public = 1;
        }else{
            $public = 0;
        }
        
        if($static_page){
            $static_page = 1;
        }else{
            $static_page = 0;
        }
        
        $sqlite_r1 = $this->db_obj->query("UPDATE `open_hongi_articles` SET `title` = '".$this->db_obj->escapeString($title)."', `user_id` = '".$this->db_obj->escapeString($user_id)."', `modified_date` = '".$this->db_obj->escapeString($modified_date)."', `main_image` = '".$this->db_obj->escapeString($main_image)."', `public` = ".$public.", `static_page` = ".$static_page." WHERE `path` = '".$this->db_obj->escapeString($path)."'");
        if($sqlite_r1 == FALSE){
            print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        if(!$static_page){
            $sqlite_r2 = $this->db_obj->query("DELETE FROM `open_hongi_categories` WHERE `path` = '".$this->db_obj->escapeString($path)."'");
            if($sqlite_r2 == FALSE){
                print "SQLコード2の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            $categories = array();
            
            for($cnt = 0; isset($category[$cnt]); $cnt++){
                $category_bunkatsu = explode("/",$category[$cnt]);
                
                for($cnt_2 = 1; isset($category_bunkatsu[$cnt_2]); $cnt_2++){
                    $category_bunkatsu[$cnt_2] = $category_bunkatsu[$cnt_2 - 1]."/".$category_bunkatsu[$cnt_2];
                }
                
                $categories = array_merge($categories,$category_bunkatsu);
            }
            
            $categories = array_values(array_unique($categories));
            
            $category_kosu = count($categories);
            for($category_c = 0; $category_c < $category_kosu; $category_c++){                
                $sqlite_r3 = $this->db_obj->query("INSERT INTO `open_hongi_categories`(`category`,`path`) VALUES ('".$this->db_obj->escapeString($categories[$category_c])."','".$this->db_obj->escapeString($path)."')");
                if ($sqlite_r3 == FALSE){
                    print "SQLコード3の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                    return FALSE;
                }
            }
            
            $sqlite_r4 = $this->db_obj->query("DELETE FROM `open_hongi_tags` WHERE `path` = '".$this->db_obj->escapeString($path)."'");
            if($sqlite_r4 == FALSE){
                print "SQLコード4の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
            
            if(strlen($tags) >= 1){
                $tag_list = explode(" ",$tags);
                $tag_kosu = count($tag_list);
                for($tag_c = 0; $tag_c < $tag_kosu; $tag_c++){
                    $sqlite_r5 = $this->db_obj->query("INSERT INTO `open_hongi_tags`(`tag`,`path`) VALUES ('".$this->db_obj->escapeString($tag_list[$tag_c])."','".$this->db_obj->escapeString($path)."')");
                    if ($sqlite_r5 == FALSE){
                        print "SQLコード5の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                        return FALSE;
                    }
                }
            }
        }
    }
    
    function search_by_category($category,$results_per_page,$page_number){
        $results_per_page = intval($results_per_page);
        $page_number = intval($page_number);
        
        $sqlite_r1 = $this->db_obj->query("SELECT `open_hongi_articles`.* FROM `open_hongi_categories`,`open_hongi_articles` WHERE `open_hongi_categories`.`category` = '".$this->db_obj->escapeString($category)."' AND `open_hongi_categories`.`path` = `open_hongi_articles`.`path` AND `open_hongi_articles`.`public` = 1 ORDER BY `open_hongi_articles`.`created_date` DESC LIMIT ".(($page_number - 1) * $results_per_page).",".intval($results_per_page));
        if($sqlite_r1 == FALSE){
            print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        $sqlite_r2 = $this->db_obj->query("SELECT COUNT(`open_hongi_articles`.`path`) AS `cnt` FROM `open_hongi_categories`,`open_hongi_articles` WHERE `open_hongi_categories`.`category` = '".$this->db_obj->escapeString($category)."' AND `open_hongi_categories`.`path` = `open_hongi_articles`.`path` AND `open_hongi_articles`.`public` = 1");
        if($sqlite_r2 == FALSE){
            print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        $kekka = array();
        for($cnt = 0; $data = $sqlite_r1->fetchArray(SQLITE3_ASSOC); $cnt++){
            $kekka["path"][$cnt] = $data["path"];
            $kekka["title"][$cnt] = $data["title"];
            $kekka["user_id"][$cnt] = $data["user_id"];
            $kekka["created_date"][$cnt] = $data["created_date"];
            $kekka["modified_date"][$cnt] = $data["modified_date"];
            $kekka["main_image"][$cnt] = $data["main_image"];
            $kekka["public"][$cnt] = $data["public"];
            $kekka["static_page"][$cnt] = $data["static_page"];
        }
        
        $data = $sqlite_r2->fetchArray(SQLITE3_ASSOC);
        if($data["cnt"] == 0){
            return NULL;
        }else{
            $kekka["count"] = $data["cnt"];
            return $kekka;
        }
    }
    
    function search_by_tag($tag,$results_per_page,$page_number){
        $results_per_page = intval($results_per_page);
        $page_number = intval($page_number);
        
        $sqlite_r1 = $this->db_obj->query("SELECT `open_hongi_articles`.* FROM `open_hongi_tags`,`open_hongi_articles` WHERE `open_hongi_tags`.`tag` = '".$this->db_obj->escapeString($tag)."' AND `open_hongi_tags`.`path` = `open_hongi_articles`.`path` AND `open_hongi_articles`.`public` = 1 ORDER BY `open_hongi_articles`.`created_date` DESC LIMIT ".(($page_number - 1) * $results_per_page).",".intval($results_per_page));
        if($sqlite_r1 == FALSE){
            print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        $sqlite_r2 = $this->db_obj->query("SELECT COUNT(`open_hongi_articles`.`path`) AS `cnt` FROM `open_hongi_tags`,`open_hongi_articles` WHERE `open_hongi_tags`.`tag` = '".$this->db_obj->escapeString($tag)."' AND `open_hongi_tags`.`path` = `open_hongi_articles`.`path` AND `open_hongi_articles`.`public` = 1");
        if($sqlite_r2 == FALSE){
            print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        $kekka = array();
        for($cnt = 0; $data = $sqlite_r1->fetchArray(SQLITE3_ASSOC); $cnt++){
            $kekka["path"][$cnt] = $data["path"];
            $kekka["title"][$cnt] = $data["title"];
            $kekka["user_id"][$cnt] = $data["user_id"];
            $kekka["created_date"][$cnt] = $data["created_date"];
            $kekka["modified_date"][$cnt] = $data["modified_date"];
            $kekka["main_image"][$cnt] = $data["main_image"];
            $kekka["public"][$cnt] = $data["public"];
            $kekka["static_page"][$cnt] = $data["static_page"];
        }
        
        $data = $sqlite_r2->fetchArray(SQLITE3_ASSOC);
        if($data["cnt"] == 0){
            return NULL;
        }else{
            $kekka["count"] = $data["cnt"];
            return $kekka;
        }
    }
    
    function search_by_keyword($keyword,$results_per_page,$page_number,$kikan = NULL,$category = NULL){
        $results_per_page = intval($results_per_page);
        $page_number = intval($page_number);
        
        $keyword_henkan_before = str_replace("　"," ",$keyword);
        
        /*不必要な半角スペースの削除*/
        while(1){
            $keyword_henkan_after = str_replace("  "," ",$keyword_henkan_before);/*2連続のスペースを1連続に変換*/
            if($keyword_henkan_after === $keyword_henkan_before){
                break;
            }
            $keyword_henkan_before = $keyword_henkan_after;
        }
    
        /*先頭のスペースを削除*/
        $kekka_pos = strpos($keyword_henkan_after," ",0);
        if($kekka_pos === 0){
            $keyword_henkan_after = substr($keyword_henkan_after,1);
        }
        
        /*末尾のスペースを削除*/
        $keyword_nagasa = strlen($keyword_henkan_after);
        if($keyword_nagasa != 0){
            $kekka_pos = strpos($keyword_henkan_after," ",$keyword_nagasa - 1);
            if($kekka_pos !== FALSE){
                $keyword_henkan_after = substr($keyword_henkan_after,0,$keyword_nagasa - 1);
            }
        }
        
        $option_date = "";
        $option_category = "";
        $category_from = "";
        
        if(strlen($keyword_henkan_after) == 0){
            return FALSE;
        }
        
        $kensaku_word = explode(" ",$keyword_henkan_after);
        $kensaku_q = "";
        
        if($kikan >= 1){
            $option_date = "AND `open_hongi_articles`.`created_date` >= '".date("Y-m-d H:i:s",time() - $kikan)."'";
        }
        
        if($category !== NULL){
            if(strlen($category) >= 1){
                $option_category = "AND `open_hongi_articles`.`path` = `open_hongi_categories`.`path` AND `open_hongi_categories`.`category` = '".$this->db_obj->escapeString($category)."'";
                $category_from = ",`open_hongi_categories`";
            }
        }
        
        for($word_cnt = 0; $word_cnt < 4 AND isset($kensaku_word[$word_cnt]); $word_cnt++){
            $word_q[$word_cnt] = $this->db_obj->escapeString($kensaku_word[$word_cnt]);
            
            if($word_cnt != 0){
                $kensaku_q = $kensaku_q." AND ";
            }
            
            if(substr($word_q[$word_cnt],0,1) === "-"){
                $word_no_minus = substr($word_q[$word_cnt],1);
                $kensaku_q = $kensaku_q."`open_hongi_articles`.`title` NOT LIKE '%".$word_no_minus."%'";
            }else{
                $kensaku_q = $kensaku_q."`open_hongi_articles`.`title` LIKE '%".$word_q[$word_cnt]."%'";
            }
        }
        
        $sqlite_r1 = $this->db_obj->query("SELECT `open_hongi_articles`.* FROM `open_hongi_articles`".$category_from." WHERE ".$kensaku_q." ".$option_date." ".$option_category." AND `open_hongi_articles`.`public` = 1 ORDER BY `open_hongi_articles`.`created_date` DESC LIMIT ".(($page_number - 1) * $results_per_page).",".intval($results_per_page));
        if ($sqlite_r1 == FALSE){
            print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        $sqlite_r2 = $this->db_obj->query("SELECT COUNT(*) AS `cnt` FROM `open_hongi_articles`".$category_from." WHERE ".$kensaku_q." ".$option_date." ".$option_category." AND `open_hongi_articles`.`public` = 1");
        if ($sqlite_r2 == FALSE){
            print "SQLコード2の実行に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        $kekka = array();
        for($cnt = 0; $data = $sqlite_r1->fetchArray(SQLITE3_ASSOC); $cnt++){
            $kekka["path"][$cnt] = $data["path"];
            $kekka["title"][$cnt] = $data["title"];
            $kekka["user_id"][$cnt] = $data["user_id"];
            $kekka["created_date"][$cnt] = $data["created_date"];
            $kekka["modified_date"][$cnt] = $data["modified_date"];
            $kekka["main_image"][$cnt] = $data["main_image"];
            $kekka["public"][$cnt] = $data["public"];
            $kekka["static_page"][$cnt] = $data["static_page"];
        }
        
        $kensu = $sqlite_r2->fetchArray(SQLITE3_ASSOC);
        $kekka["count"] = $kensu["cnt"];
        
        $kekka["keyword"] = $word_q;
        
        return $kekka;
    }
    
    function get_tags($category = NULL,$limit = 32){
        if($category !== NULL){
            $sqlite_r1 = $this->db_obj->query("SELECT `open_hongi_tags`.`tag`, COUNT(*) AS `cnt` FROM `open_hongi_tags`,`open_hongi_articles`,`open_hongi_categories` WHERE `open_hongi_categories`.`category` = '".$this->db_obj->escapeString($category)."' AND `open_hongi_articles`.`path` = `open_hongi_categories`.`path` AND `open_hongi_articles`.`path` = `open_hongi_tags`.`path` AND `open_hongi_articles`.`public` = 1 GROUP BY `open_hongi_tags`.`tag` ORDER BY MAX(`open_hongi_articles`.`created_date`) DESC LIMIT 0,".intval($limit));
            if($sqlite_r1 == FALSE){
                print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }else{
            $sqlite_r1 = $this->db_obj->query("SELECT `open_hongi_tags`.`tag`, COUNT(*) AS `cnt` FROM `open_hongi_tags`,`open_hongi_articles` WHERE `open_hongi_articles`.`path` = `open_hongi_tags`.`path` AND `open_hongi_articles`.`public` = 1 GROUP BY `open_hongi_tags`.`tag` ORDER BY MAX(`open_hongi_articles`.`created_date`) DESC LIMIT 0,".intval($limit));
            if($sqlite_r1 == FALSE){
                print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }
        
        $kekka = array();
        $kekka["count_max"] = 0;
        for($cnt = 0; $q_kekka = $sqlite_r1->fetchArray(SQLITE3_ASSOC); $cnt++){
            $kekka["tag"][$cnt] = $q_kekka["tag"];
            $kekka["count"][$cnt] = $q_kekka["cnt"];
            if($kekka["count_max"] < $q_kekka["cnt"]){
                $kekka["count_max"] = $q_kekka["cnt"];
            }
        }
        
        return $kekka;
    }
    
    function get_recent_articles($category = NULL){
        include_once "../lib/wakarana/main.php";
        
        $wakarana = new wakarana();
        
        $kekka = array();
        
        if($category !== NULL){
            $sqlite_r1 = $this->db_obj->query("SELECT `open_hongi_articles`.*, strftime('%s',`open_hongi_articles`.`created_date`) AS `created_date_ts`, strftime('%s',`open_hongi_articles`.`modified_date`) AS `modified_date_ts` FROM `open_hongi_articles`,`open_hongi_categories` WHERE `open_hongi_articles`.`path` = `open_hongi_categories`.`path` AND `open_hongi_categories`.`category` = '".$this->db_obj->escapeString($category)."' AND `open_hongi_articles`.`static_page` = 0 AND `open_hongi_articles`.`public` = 1 ORDER BY `open_hongi_articles`.`created_date` DESC LIMIT 0,24");
            if($sqlite_r1 == FALSE){
                print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }else{
            $sqlite_r1 = $this->db_obj->query("SELECT *, strftime('%s',`created_date`) AS `created_date_ts`, strftime('%s',`modified_date`) AS `modified_date_ts` FROM `open_hongi_articles` WHERE `static_page` = 0 AND `public` = 1 ORDER BY `created_date` DESC LIMIT 0,24");
            if($sqlite_r1 == FALSE){
                print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
                return FALSE;
            }
        }
        
        if($this->dir_path === "/"){
            $kaiso = "";
        }else{
            $kaiso = substr($this->dir_path,1);
        }
        
        $kekka["recent_articles"] = "";
        $kekka["recent_articles_side"] = "";
        
        $time_s = time();
        $kaigyo = array("\n","\r");
        
        $yobi_list = array("日","月","火","水","木","金","土");
        
        $kekka["atom"] = "<?xml version='1.0' encoding='UTF-8'?>\n"
                ."<feed xmlns='http://www.w3.org/2005/Atom' xml:lang='ja'>\n"
                ."    <id>tag:".$_SERVER["SERVER_NAME"].",".$this->sys_conf["setup_date"].":".$kaiso."main</id>\n"
                ."    <title>".$this->setting["title"]."</title>\n"
                ."    <subtitle>".$this->setting["subtitle"]."</subtitle>\n"
                ."    <link rel='alternate' type='text/html' href='http://".$_SERVER["SERVER_NAME"].$this->dir_path."'/>\n"
                ."    <link rel='self' type='application/atom+xml' href='http://".$_SERVER["SERVER_NAME"].$this->dir_path."feed/index.atom'/>\n"
                ."    <updated>".date("Y-m-d",$time_s)."T".date("H:i:s",$time_s)."+09:00</updated>\n";
        
        $author_name = array();
        
        for($cnt = 1; $q_kekka = $sqlite_r1->fetchArray(SQLITE3_ASSOC); $cnt++){
            
            $time_s = $q_kekka["created_date_ts"];
            $created_date = date("Y/n/j",intval($time_s) - 32400)." (".$yobi_list[intval(date("w",intval($time_s) - 32400))].") ".date("A g:i",intval($time_s) - 32400);
            
            if($category === NULL){
                $kekka["recent_articles"] = $kekka["recent_articles"]."title[".$cnt."]=\"".$q_kekka["title"]."\"\npath[".$cnt."]=\"".$q_kekka["path"]."\"\ncreated_date[".$cnt."]=\"".$created_date."\"\nmain_image[".$cnt."]=\"".$q_kekka["main_image"]."\"\n";
                
                if($cnt <= 8){
                    $kekka["recent_articles_side"] = $kekka["recent_articles_side"]."<a href='".$this->dir_path."blog.php/".$q_kekka["path"]."' class='image_link'>\n";
                    
                    if(strlen($q_kekka["main_image"]) != 0){
                        $kekka["recent_articles_side"] = $kekka["recent_articles_side"]."<img src='".$this->dir_path."image/".$q_kekka["main_image"]."_150.jpeg' alt=''>\n";
                    }
                    
                    $kekka["recent_articles_side"] = $kekka["recent_articles_side"].$q_kekka["title"]."\n</a>\n";
                }
            }else{
                if($cnt <= 4){
                    $kekka["recent_articles"] = $kekka["recent_articles"]."title[".$cnt."]=\"".$q_kekka["title"]."\"\npath[".$cnt."]=\"".$q_kekka["path"]."\"\ncreated_date[".$cnt."]=\"".$created_date."\"\n";
                }
            }
            
            $content_html = file_get_contents("../entries/".$q_kekka["path"]."_content.html");
            $content_naiyo = preg_replace("/&.*;/","",mb_substr(strip_tags(str_replace($kaigyo,"",str_replace("<br>"," ",$content_html))),0,1000));
            if($amp_pos = mb_strpos($content_naiyo,"&")){
                mb_substr($content_naiyo,0,$amp_pos);
            }
            
            if(!isset($author_name[$q_kekka["user_id"]])){
               $user_info = $wakarana->get_user_info($q_kekka["user_id"],FALSE);
               $author_name[$q_kekka["user_id"]] = $user_info["user_name"];
            }
            
            $kekka["atom"] = $kekka["atom"]
                    ."    <entry>\n"
                    ."        <id>tag:".$_SERVER["SERVER_NAME"].",".$this->sys_conf["setup_date"].":".$kaiso.$q_kekka["path"]."</id>\n"
                    ."        <title>".$q_kekka["title"]."</title>\n"
                    ."        <link rel='alternate' type='text/html' href='http://".$_SERVER["SERVER_NAME"].$this->dir_path."blog.php/".$q_kekka["path"]."'/>\n"
                    ."        <published>".date("Y-m-d",$q_kekka["created_date_ts"]- 32400)."T".date("H:i:s",$q_kekka["created_date_ts"]- 32400)."+09:00</published>\n"
                    ."        <updated>".date("Y-m-d",$q_kekka["modified_date_ts"]- 32400)."T".date("H:i:s",$q_kekka["modified_date_ts"]- 32400)."+09:00</updated>\n"
                    ."        <author><name>".$author_name[$q_kekka["user_id"]]."</name></author>\n"
                    ."        <summary>".$content_naiyo."</summary>\n"
                    ."        <content type=\"html\">".htmlspecialchars("<img src='".$this->dir_path."image/".$q_kekka["main_image"]."_600.jpeg' alt='".htmlspecialchars($q_kekka["title"])."'>".$content_html,ENT_HTML5)."</content>\n"
                    ."    </entry>\n";
        }
        
        $kekka["atom"] = $kekka["atom"]."</feed>";
        
        if($category === NULL){
            $tag_list = $this->get_tags(NULL,48);
        }else{
            $tag_list = $this->get_tags($category,24);
        }
        
        $kekka["tag"] = "";
        for($cnt = 0; isset($tag_list["tag"][$cnt]); $cnt++){
            $kekka["tag"] = $kekka["tag"]."<a href='".$this->dir_path."archive/tag.php/".urlencode($tag_list["tag"][$cnt])."' ";
            if($tag_list["count"][$cnt] < $tag_list["count_max"] / 64){
                $kekka["tag"] = $kekka["tag"]."style='font-size: 71%;'>";
            }elseif($tag_list["count"][$cnt] < $tag_list["count_max"] / 16){
                $kekka["tag"] = $kekka["tag"]."style='font-size: 100%;'>";
            }elseif($tag_list["count"][$cnt] < $tag_list["count_max"] / 4){
                $kekka["tag"] = $kekka["tag"]."style='font-size: 141%;'>";
            }else{
                $kekka["tag"] = $kekka["tag"]."style='font-size: 200%;'>";
            }
            
            $kekka["tag"] = $kekka["tag"].htmlspecialchars($tag_list["tag"][$cnt])."</a>(".$tag_list["count"][$cnt].") ";
        }
        
        return $kekka;
    }
    
    function  get_hidden_pages(){
        $kekka = array();
        
        $sqlite_r1 = $this->db_obj->query("SELECT * FROM `open_hongi_articles` WHERE `public` = 0 ORDER BY `created_date` DESC LIMIT 0,300");
        if($sqlite_r1 == FALSE){
            print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        for($cnt = 0; $q_kekka = $sqlite_r1->fetchArray(SQLITE3_ASSOC); $cnt++){
            $kekka["path"][$cnt] = $q_kekka["path"];
            $kekka["title"][$cnt] = $q_kekka["title"];
            $kekka["user_id"][$cnt] = $q_kekka["user_id"];
            $kekka["created_date"][$cnt] = $q_kekka["created_date"];
            $kekka["modified_date"][$cnt] = $q_kekka["modified_date"];
            $kekka["main_image"][$cnt] = $q_kekka["main_image"];
            $kekka["public"][$cnt] = $q_kekka["public"];
            $kekka["static_page"][$cnt] = $q_kekka["static_page"];
        }
        
        $sqlite_r2 = $this->db_obj->query("SELECT COUNT(*) AS `cnt` FROM `open_hongi_articles` WHERE `public` = 0");
        if($sqlite_r2 == FALSE){
            print "SQLコード1の実行に失敗しました。".$this->db_obj->lastErrorMsg();
            return FALSE;
        }
        
        $q_kekka = $sqlite_r2->fetchArray(SQLITE3_ASSOC);
        
        $kekka["cnt"] = $q_kekka["cnt"];
        
        return $kekka;
    }
}
