<?php
include "../common/main.php";

include "../lib/wakarana/main.php";

$wakarana = new wakarana();
$user_id = $wakarana->check();
if($user_id == FALSE){
    header("Location: index.php?go_to=".urlencode(basename($_SERVER['PHP_SELF'])));
    exit(0);
}
$user_info = $wakarana->get_user_info($user_id,FALSE);

header("X-Frame-Options: SAMEORIGIN");
?><!DOCTYPE html>
<html>
    <head>
<?php head_include();
print "<title>著者情報の編集 | ".$setting["title"]."</title>";
?>
        <script type="text/javascript" src="owner.js"></script>
        <link rel="stylesheet" href="owner.css" type="text/css">
    </head>
    <body>
<?php header_include(); ?>
                <div id="content">
<h1>著者情報の編集</h1>
<?php
if(isset($_POST["user_id"])){
    if($wakarana->check_privilege($user_id,"master") || $_POST["user_id"] === $user_id){
        $user_id_2 = $_POST["user_id"];
    }else{
        print "<div style='color: #ff0000; font-weight: bold; background-color: #ffcccc; padding: 16px;'>あなたには他のアカウントを編集する権限が付与されていません</div>";
        goto page_end;
    }
}elseif(isset($_GET["user_id"])){
    if($wakarana->check_privilege($user_id,"master")){
        $user_id_2 = $_GET["user_id"];
    }else{
        print "<div style='color: #ff0000; font-weight: bold; background-color: #ffcccc; padding: 16px;'>あなたには他のアカウントを編集する権限が付与されていません</div>";
        goto page_end;
    }
}else{
    $user_id_2 = $user_id;
}

if(isset($_POST["given_name"],$_POST["family_name"],$_POST["display_name"],$_POST["image_id"],$_POST["page"],$_POST["email"],$_POST["introduction"])){
    $author_naiyo = "given_name=\"".htmlspecialchars($_POST["given_name"])."\"\n"
            ."family_name=\"".htmlspecialchars($_POST["family_name"])."\"\n"
            ."display_name=\"".htmlspecialchars($_POST["display_name"])."\"\n"
            ."image_id=\"".htmlspecialchars($_POST["image_id"])."\"\n"
            ."page=\"".htmlspecialchars($_POST["page"])."\"\n"
            ."email=\"".htmlspecialchars($_POST["email"])."\"\n"
            ."introduction=\"".str_replace("\"","\\\"",str_replace("\\","\\\\",$_POST["introduction"]))."\"\n";
    
    $author_html = "<a href='".$_POST["page"]."' rel='author' class='author'>";
    if(!empty($_POST["image_id"])){
        $author_html  = $author_html ."<img src='".$dir_path."image/".$_POST["image_id"]."_150.jpeg' alt='".$author_data["display_name"]."'><br>";
    }else{
        $style_data = parse_ini_file("../style/style_data.ini");
        $author_html  = $author_html ."<img src='".$dir_path."style/".$style_data["default_author_image"]."' alt='".$author_data["display_name"]."'><br>";
    }
    $author_html = $author_html.$_POST["display_name"]
            ."</a>\n"
            .$_POST["introduction"]."<br>\n";
    
    if(isset($_POST["token"]) && $wakarana->check_one_time_token($user_id,$_POST["token"])){
        file_put_contents("../config/authors/".$user_id_2.".ini",$author_naiyo);
        
        file_put_contents("../config/authors/".$user_id_2.".html",$author_html);
        
        $top_authors = parse_ini_file("../config/top_authors.ini");
        if(!empty($top_authors) && array_search($user_id_2,$top_authors["user_id"]) !== FALSE){
            include "../modules/authors.php";
            $authors = new open_hongi_authors();
            
            $authors->update_top_html();
        }
        
        print "<span style='font-size: x-large;'>変更を保存しました。</span><br>";
    }else{
        print "<div style='color: #ff0000; font-weight: bold; background-color: #ffcccc; padding: 16px;'>ワンタイムトークンが無効です。<br>フォームの内容を再送信してください。</div>";
    }
}

$author = parse_ini_file("../config/authors/".$user_id_2.".ini");

print "<form action='author_data.php' method='post' name='write_form'>";

print "<h4>ユーザーID：</h4>";
print "<input type='hidden' name='user_id' value='".$user_id_2."'>";
print "<b style='font-size: x-large;'>".$user_id_2."</b><br>";
print "※ユーザーIDは変更できません。<br>";

print "<h4>著者氏名：</h4>";
print "姓: <input type='text' name='family_name' value='".$author["family_name"]."' style='font-size: x-large; width: 100px;'>　名: <input type='text' name='given_name' value='".$author["given_name"]."' style='font-size: x-large; width: 100px;'><br>";
print "この著者氏名は一般には公開されません。<br>";

print "<h4>表示名：</h4>";
print "<input type='text' name='display_name' value='".$author["display_name"]."' style='font-size: x-large; width: 300px;'><br>";

print "<h4>著者画像：</h4>";
print "<input type='text' id='image_id' name='image_id' style='width: 300px;' value='".$author["image_id"]."'> ";
print "<button type='button' href='javascript: void(0);' onclick='image_sansho(true,\"image_id\");'>参照</button><br>";
?>
<div id="image_kakunin"></div>
<script type="text/javascript">
    function image_kakunin(){
        var image_id_val = document.getElementById("image_id").value;
        var image_kakunin_box = document.getElementById("image_kakunin");
        if(image_id_val.length > 0){
            image_kakunin_box.innerHTML = "<img src='" + dir_path + "image/" + image_id_val + "_150.jpeg' alt=''>";
        }else{
            image_kakunin_box.innerHTML = "";
        }
    }
    
    window.addEventListener("load",image_kakunin);
</script>
<?php

print "<h4>著者紹介ページ：</h4>";
print "著者紹介ページのURLを指定してください。<br>";
print "<input type='text' name='page' style='width: 300px;' value='".$author["page"]."'><br>";

print "<h4>メールアドレス：</h4>";
print "<input type='text' name='email' style='width: 350px;' value='".$author["email"]."'><br>";
print "このメールアドレスは一般には公開されません。<br>また、この項目は空欄でも構いません。<br>";

print "<h4>紹介文：</h4>";
print "<script type='text/javascript' src='../lib/hongi_editor_2/main.js'></script>";
print "<textarea name='introduction' style='width: 180px; height: 300px;'>".$author["introduction"]."</textarea>";
print "<script type='text/javascript'>hongi_editor_include('introduction');hongi_editor_set_browse_image_function('image_sansho_hongi_editor');</script>";
print "紹介文のHTML中にメールアドレスをそのまま記述すると、悪意のあるソフトウェアによってメールアドレスを収集される危険性を伴います。<br>メールアドレスを画像にするなどして、対策を行うことをお勧めします。<br><br>";

print "<input type='hidden' name='token' value='".$wakarana->create_one_time_token($user_id)."'>";

print "<button type='submit' style='font-size: x-large;'>編集確定</button>";
print "</form>";

page_end:
?>
            <br>
            <br>
            <a href="main.php">&lt;&lt;コントロールパネルTOP</a><br>
                </div>
                <div id="side">
                    <?php include "side.php"; ?>
                </div>
<?php footer_include(); ?>
    </body>
</html><!--Powered by Open本紀-->