<?php
include "../common/main.php";

include "../lib/wakarana/main.php";

$wakarana = new wakarana();
$user_id = $wakarana->check("master");
if($user_id == FALSE){
    header("Location: index.php?go_to=".urlencode(basename($_SERVER['PHP_SELF'])));
    exit(0);
}
$user_info = $wakarana->get_user_info($user_id,FALSE);

header("X-Frame-Options: SAMEORIGIN");
?><!DOCTYPE html>
<html>
    <head>
<?php head_include();
print "<title>カテゴリーの編集 | ".$setting["title"]."</title>";
?>
        <script type="text/javascript" src="owner.js"></script>
        <link rel="stylesheet" href="owner.css" type="text/css">
    </head>
    <body>
<?php header_include(); ?>
                <div id="content">
<h1>カテゴリーの編集</h1>
<script type="text/javascript">
function show_addform(dir){
    document.getElementById("add_form").style.display = "block";
    document.getElementById("screen").style.display = "block";
    document.getElementById("dir").value = dir;
    if(dir != "/"){
        document.getElementById("insert_pos").innerText = "追加先：" + dir;
    }else{
        document.getElementById("insert_pos").innerText = "一番上の階層に追加します";
    }
}

function close_add_form(){
    document.getElementById("add_form").style.display = "none";
    document.getElementById("screen").style.display = "none";
}

function show_delform(del_category){
    document.getElementById("del_form").style.display = "block";
    document.getElementById("screen").style.display = "block";
    document.getElementById("del_category").value = del_category;
    
    document.getElementById("del_insert_pos").innerText = del_category;
}

function close_del_form(){
    document.getElementById("del_form").style.display = "none";
    document.getElementById("screen").style.display = "none";
}
</script>
<?php


function update_categories_html(){
    global $dir_path;
    global $categories;
    
    $list = array_keys($categories["dir"],"/");
    
    $categories_html = "";
    $categories_m_html = "";
    
    for($cnt = 0; isset($list[$cnt]); $cnt++){
        $categories_html = $categories_html."<a href='".$dir_path."archive/category.php/".urlencode($categories["category"][$list[$cnt]])."' class='small_link'>".htmlspecialchars($categories["category"][$list[$cnt]])."</a>\n";
        $categories_m_html = $categories_m_html."<li><a href='".$dir_path."archive/category.php/".urlencode($categories["category"][$list[$cnt]])."'>".htmlspecialchars($categories["category"][$list[$cnt]])."</a></li>\n";
    }
    
    file_put_contents("../config/categories.html",$categories_html);
    file_put_contents("../config/categories_m.html","<ul>\n".$categories_m_html."</ul>\n");
}


$categories = parse_ini_file("../config/categories.ini");

if(isset($_POST["dir"],$_POST["category_name"])){
    if(isset($_POST["token"]) && $wakarana->check_one_time_token($user_id,$_POST["token"])){
        if(isset($categories["dir"])){
            $number = count($categories["dir"]);
        }else{
            $number = 0;
        }
        
        $file_h = fopen("../config/categories.ini",'a');
            
        fwrite($file_h,"dir[".$number."]=\"".addslashes($_POST["dir"])."\"\r\n");
        fwrite($file_h,"category[".$number."]=\"".addslashes($_POST["category_name"])."\"\r\n");
        
        fclose($file_h);
        
        if($_POST["dir"] === "/"){
            touch("../entries/recent_articles_categories/".mb_convert_encoding($_POST["category_name"],$sys_conf["file_name_code"],"auto").".ini");
            touch("../entries/tags_categories/".mb_convert_encoding($_POST["category_name"],$sys_conf["file_name_code"],"auto").".html");
        }
        
        print "<span style='font-size: x-large;'>指定されたカテゴリーを追加しました。</span><br><br>";
        
        $categories = parse_ini_file("../config/categories.ini");
        
        update_categories_html();
    }else{
        print "<div style='color: #ff0000; font-weight: bold; background-color: #ffcccc; padding: 16px;'>ワンタイムトークンが無効です。<br>フォームの内容を再送信してください。</div>";
    }
}


if(isset($_POST["del_category"])){
    if($wakarana->check_one_time_token($user_id,$_POST["token"])){
        $keys = array_keys($categories["dir"],substr($_POST["del_category"],0,strrpos($_POST["del_category"],"/",-1) + 1));
        
        $del_category_name = substr($_POST["del_category"],strrpos($_POST["del_category"],"/",-1) + 1);
        for($cnt = 0; isset($keys[$cnt]); $cnt++){
            if($categories["category"][$keys[$cnt]] === $del_category_name){
                array_splice($categories["category"],$keys[$cnt],1);
                array_splice($categories["dir"],$keys[$cnt],1);
                
                break;
            }
        }
        
        $del_category_length = strlen($_POST["del_category"]) + 1;
        for($cnt = 0; $cnt < count($categories["category"]); $cnt++){
            if(substr($categories["dir"][$cnt],0,$del_category_length) === $_POST["del_category"]."/"){
                array_splice($categories["category"],$cnt,1);
                array_splice($categories["dir"],$cnt,1);
                
                $cnt--;
            }
        }
        
        if(!empty($categories["category"])){
            
            $file_h = fopen("../config/categories.ini",'w');
            for($cnt = 0; isset($categories["category"][$cnt]); $cnt++){
                fwrite($file_h,"dir[".$cnt."]=\"".addslashes($categories["dir"][$cnt])."\"\r\n");
                fwrite($file_h,"category[".$cnt."]=\"".addslashes($categories["category"][$cnt])."\"\r\n");
            }
            fclose($file_h);
            
            print "<span style='font-size: x-large;'>指定されたカテゴリーを削除しました。</span><br><br>";
            
            $categories = parse_ini_file("../config/categories.ini");
            
            update_categories_html();
        }else{
            print "<span style='font-size: x-large; color: #ff0000;'>エラー: カテゴリーは1つ以上必要です。</span><br><br>";
            
            $categories = parse_ini_file("../config/categories.ini");
        }
    }else{
        print "<div style='color: #ff0000; font-weight: bold; background-color: #ffcccc; padding: 16px;'>ワンタイムトークンが無効です。<br>フォームの内容を再送信してください。</div>";
    }
}


if(isset($categories["dir"])){
    print "カテゴリー名をクリックすると、そのカテゴリーの下に新しいカテゴリーを挿入します。<br><br><span style='font-size: x-large; line-height: 150%;'>";
    
    $list = array_keys($categories["dir"],"/");
    
    $kaiso = array();
    
    $kosu = count($list);
    for($cnt_2 = 0; $cnt_2 < $kosu; $cnt_2++){
        $kaiso[] = 0;
    }
    
    for($cnt = 0; isset($list[$cnt]); $cnt++){
        $list_2 = array_keys($categories["dir"],$categories["dir"][$list[$cnt]].$categories["category"][$list[$cnt]]."/");
        array_splice($list,$cnt + 1,0,$list_2);
        
        $kaiso_2 = array();
        
        $kosu = count($list_2);
        for($cnt_2 = 0; $cnt_2 < $kosu; $cnt_2++){
            $kaiso_2[] = $kaiso[$cnt] + 1;
        }
        array_splice($kaiso,$cnt + 1,0,$kaiso_2);
        
        print str_repeat("　",$kaiso[$cnt])."└<a href='javascript:void(0);' onclick='show_addform(\"".$categories["dir"][$list[$cnt]].$categories["category"][$list[$cnt]]."/\")'>".$categories["category"][$list[$cnt]]."</a> [<a href='javascript:void(0);' onclick=\"show_delform('".$categories["dir"][$list[$cnt]].$categories["category"][$list[$cnt]]."');\">×</a>]<br>\n";
    }
    
    print "</span>";
}else{
    print "<span style='font-size: x-large;'>カテゴリーは未設定です。</span><br>下のボタンからカテゴリーを追加してください。<br>";
}
?>
<br>
<button type='button' onclick="show_addform('/');">一番上の階層にカテゴリーを追加</button><br>
<br>
<a href="main.php">&lt;&lt;管理者トップページ</a>
<div id="screen" style="display: none; position: fixed; z-index: 128; top: 0; left: 0; width: 100%; height: 100%; background-color: rgba(0,0,0,0.75)">
<?php
$token = $wakarana->create_one_time_token($user_id);
?>
<form action='categories.php' method='post' style="display: none; width: 310px; height: 320px; padding-left: 10px; position: fixed; top: calc(50% - 150px); left: calc(50% - 150px); background-color: #ffffff;" id="add_form">
    <div style="float: right; width: 32px; padding-top: 8px; font-size: x-large; color: #999999; cursor: pointer;" onclick="close_add_form();">×</div>
    <input name="dir" type="hidden" value="" id="dir">
    <br style="clear: both;"><br>
    カテゴリー名には、半角スラッシュは使用しないでください。
    <h4>追加するカテゴリー名：</h4>
    <input name="category_name" type="text" value="" style="width: 300px; font-size: x-large;"><br>
    <span id="insert_pos"></span>
    <br>
<?php
print "<input type='hidden' name='token' value='".$token."'>";
?>
    <button type="submit" style="font-size: x-large; float: right; margin-right: 20px;">追加</button>
</form>
<form action='categories.php' method='post' style="display: none; width: 310px; height: 320px; padding-left: 10px; position: fixed; top: calc(50% - 150px); left: calc(50% - 150px); background-color: #ffffff;" id="del_form">
    <div style="float: right; width: 32px; padding-top: 8px; font-size: x-large; color: #999999; cursor: pointer;" onclick="close_del_form();">×</div>
    <input name="del_category" type="hidden" value="" id="del_category">
    <br style="clear: both;"><br>
    このカテゴリーを削除しますか？<br>
    このカテゴリーの子カテゴリーも同時に削除されます。<br>
    <br>
    <span id="del_insert_pos" style="font-size: large; font-weight: bold;"></span>
    <br>
<?php
print "<input type='hidden' name='token' value='".$token."'>";
?>
    <button type="submit" style="font-size: x-large; float: right; margin-right: 20px;">削除</button>
</form>
</div>
                </div>
                <div id="side">
                    <?php include "side.php"; ?>
                </div>
<?php footer_include(); ?>
    </body>
</html><!--Powered by Open本紀-->