<?php
include "../common/main.php";

include "../lib/wakarana/main.php";

$wakarana = new wakarana();
$user_id = $wakarana->check();
if($user_id == FALSE){
    header("Location: index.php?go_to=".urlencode(basename($_SERVER['PHP_SELF'])));
    exit(0);
}
$user_info = $wakarana->get_user_info($user_id,FALSE);

header("X-Frame-Options: SAMEORIGIN");
?><!DOCTYPE html>
<html>
    <head>
<?php head_include();

print "<title>既存の画像の編集 | ".$setting["title"]."</title>";
?>
        <script type="text/javascript" src="owner.js"></script>
        <link rel="stylesheet" href="owner.css" type="text/css">
    </head>
    <body>
<?php header_include(); ?>
<div id="content">
    <h1>既存の画像の管理</h1>
<?php
if(isset($_GET["image_id"])){
    include "../lib/chonmage_core/main.php";
    $chonmage = new chonmage();
    
    $image_info = $chonmage->get_image_info($_GET["image_id"]);
    if($image_info === FALSE){
        print "<span style='font-size: x-large; font-weight: bold;'>指定された画像は存在しません。</span>";
    }else{
        if(isset($_FILES["up_file"])){
            if(isset($_POST["token"]) && $wakarana->check_one_time_token($user_id,$_POST["token"])){
                $kekka = $chonmage->replace_image($_GET["image_id"],$_FILES["up_file"]["tmp_name"]);
                
                if($kekka){
                    print "<h2>画像ファイルの再アップロードに成功しました。</h2>";
                    
                    print "<h3>アップロードされた画像：</h3>";
                    print "<img src='".$dir_path."image/".$_GET["image_id"]."_150.jpeg?tekito=".time()."' alt=''><br>";
                }else{
                    print "<span style='font-size: x-large; font-weight: bold;'>画像ファイルのアップロードに失敗しました。</span><br>";
                }
            }else{
                print "<div style='color: #ff0000; font-weight: bold; background-color: #ffcccc; padding: 16px;'>ワンタイムトークンが無効です。<br>変更は破棄されました。</div>";
            }
        }elseif(isset($_POST["alt"])){
            if(isset($_POST["token"]) && $wakarana->check_one_time_token($user_id,$_POST["token"])){
                $kekka = $chonmage->update_image_info($_GET["image_id"],$_POST["author_id"],$_POST["alt"],$_POST["description"],$_POST["tag"]);
                
                if($kekka){
                    print "<span style='font-size: x-large; font-weight: bold;'>画像の説明を変更しました。</span><br>";
                }else{
                    print "<span style='font-size: x-large; font-weight: bold;'>画像の説明の変更に失敗しました。</span><br>";
                }
            }else{
                print "<div style='color: #ff0000; font-weight: bold; background-color: #ffcccc; padding: 16px;'>ワンタイムトークンが無効です。<br>変更は破棄されました。</div>";
            }
        }elseif(isset($_POST["delete_ok"])){
            if(isset($_POST["token"]) && $wakarana->check_one_time_token($user_id,$_POST["token"])){
                $kekka = $chonmage->delete_image($_GET["image_id"]);
                
                if($kekka){
                    print "<span style='font-size: x-large; font-weight: bold;'>画像ファイルを削除しました。</span><br>";
                }else{
                    print "<span style='font-size: x-large; font-weight: bold;'>画像ファイルの削除に失敗しました。</span><br>";
                }
            }else{
                print "<div style='color: #ff0000; font-weight: bold; background-color: #ffcccc; padding: 16px;'>ワンタイムトークンが無効です。<br>変更は破棄されました。</div>";
            }
        }
        
        $token = $wakarana->create_one_time_token($user_id);
        
        print "<h3>編集する画像：</h3>";
        print "<img src='".$dir_path."image/".$_GET["image_id"]."_150.jpeg' alt='".$image_info["image_title"]."'><br>";
        print "<span style='font-size: large;'>画像ID: ".$_GET["image_id"]."</span><br><br>";
        print "<a href='image_edit.php'>別の画像を編集</a><br><br>";
        
        print "<form action='image_edit.php?image_id=".$_GET["image_id"]."' method='post' enctype='multipart/form-data'>";
        print "<h3>画像ファイルの再アップロード(8MBまで)：</h3>";
        print "<input type='hidden' name='MAX_FILE_SIZE' value='8388608'><input type='file' name='up_file'><br><br>";
        print "<input type='hidden' name='token' value='".$token."'>";
        print "<button type='submit' style='width: 150px; height: 30px; padding: 5px;'>アップロード</button>";
        print "</form><br>";
        
        print "<form action='image_edit.php?image_id=".$_GET["image_id"]."' method='post'>";
        print "<h3>画像の説明の変更</h3>";
        print "<h4>この画像のタイトル(alt)：</h4><input type='text' name='alt' style='width: 300px;' value='".$image_info["image_title"]."'><br><br>";
        print "<b>この画像のタグ(スペースで区切って10個まで)：</b><br><input type='text' name='tag' style='width: 300px;' value='";
        if(is_array($image_info["tags"])){
            foreach($image_info["tags"] as $tag){
                print $tag." ";
            }
        }
        print "'><br><br>";
        print "<b>この画像の説明：</b><br><textarea name='description' style='width: 300px;'>".$image_info["description"]."</textarea><br><br>";
        print "<b>投稿者：</b><br><input type='text' name='author_id' style='width: 300px;' value='".$image_info["author_id"]."'><br><br>";
        print "<input type='hidden' name='token' value='".$token."'>";
        print "<button type='submit' style='width: 150px; height: 30px; padding: 5px;'>変更を確定</button>";
        print "</form><br>";
        
        print "<form action='image_edit.php?image_id=".$_GET["image_id"]."' method='post'>";
        print "<h3>画像の削除</h3>";
        print "一度削除した画像は元には戻せません。<br>本当に削除する場合は、チェックボックスにチェックをつけてからボタンをクリックしてください。<br><br>";
        print "<input type='checkbox' name='delete_ok' value='yes'>本当に削除する<br><br>";
        print "<input type='hidden' name='token' value='".$token."'>";
        print "<button type='submit' style='width: 150px; height: 30px; padding: 5px;'>削除実行</button>";
        print "</form><br>";
    }
}else{
    print "<form action='image_edit.php' method='get' name='write_form'>";
    print "編集する画像のIDを入力してください。<br>";
    print "<input type='text' id='image_id' name='image_id' style='width: 500px; font-size: x-large;'> <button type='button' onclick='image_sansho(true,\"image_id\");' style='font-size: x-large;'>参照</button><br><br>";
?>
<div id="image_kakunin"></div>
<script type="text/javascript">
    function image_kakunin(){
        var image_id_val = document.getElementById("image_id").value;
        var image_kakunin_box = document.getElementById("image_kakunin");
        if(image_id_val.length > 0){
            image_kakunin_box.innerHTML = "<img src='" + dir_path + "image/" + image_id_val + "_150.jpeg' alt=''>";
        }else{
            image_kakunin_box.innerHTML = "";
        }
    }
</script>
<?php
    print "<button type='submit' style='width: 150px; font-size: x-large;'>編集開始</button>";
    print "</form>";
}
?>
<br>
<br>
<a href="main.php">&lt;&lt; 管理者トップページ</a>
</div>
<div id="side">
<?php
include "side.php";
?>
</div>
<?php footer_include(); ?>
    </body>
</html><!--Powered by Open本紀-->