<?php
include "../common/main.php";

include "../lib/wakarana/main.php";

$wakarana = new wakarana();
$user_id = $wakarana->check("master");
if($user_id == FALSE){
    header("Location: index.php?go_to=".urlencode(basename($_SERVER['PHP_SELF'])));
    exit(0);
}
$user_info = $wakarana->get_user_info($user_id,FALSE);

header("X-Frame-Options: SAMEORIGIN");
?><!DOCTYPE html>
<html>
    <head>
<?php head_include();
print "<title>ユーザー管理 | ".$setting["title"]."</title>";
?>
        <script type="text/javascript" src="owner.js"></script>
        <link rel="stylesheet" href="owner.css" type="text/css">
    </head>
    <body>
<?php header_include(); ?>
                <div id="content">
<h1>ユーザー管理</h1>
<?php
include "../modules/authors.php";
$authors = new open_hongi_authors();

if(isset($_POST["user_id"])){
    if(isset($_POST["token"]) && $wakarana->check_one_time_token($user_id,$_POST["token"])){
        if(isset($_POST["status"])){
            $kakka = $authors->change_status($_POST["user_id"]);
            
            if($kakka === WAKARANA_STATUS_DISABLE){
                print "<span style='font-size: x-large;'>指定されたユーザー「".$_POST["user_id"]."」を停止しました。</span>";
            }else{
                print "<span style='font-size: x-large;'>指定されたユーザー「".$_POST["user_id"]."」を有効化しました。</span>";
            }
        }elseif(isset($_POST["delete"])){
            $authors->delete_author($_POST["user_id"]);
            
            print "<span style='font-size: x-large;'>指定されたユーザー「".$_POST["user_id"]."」を削除しました。</span>";
        }elseif(isset($_POST["create"])){
            if(isset($_POST["password"],$_POST["user_name"],$_POST["is_master"])){
                if($_POST["is_master"] == "yes"){
                    $kekka = $authors->add_author($_POST["user_id"],$_POST["password"],$_POST["user_name"],TRUE);
                }else{
                    $kekka = $authors->add_author($_POST["user_id"],$_POST["password"],$_POST["user_name"],FALSE);
                }
                
                if($kekka){
                    print "<span style='font-size: x-large;'>新しいユーザー「".htmlspecialchars($_POST["user_name"])."」を作成しました。</span>";
                }else{
                    print "<span style='font-size: x-large; color: #ff0000;'>ユーザーの作成に失敗しました。。</span>";
                }
            }else{
                print "<span style='font-size: x-large; color: #ff0000;'>エラー<br>フォームが正常に送信されていません。</span>";
            }
        }else{
            print "<span style='font-size: x-large; color: #ff0000;'>エラー</span>";
        }
    }else{
        print "<div style='color: #ff0000; font-weight: bold; background-color: #ffcccc; padding: 16px;'>ワンタイムトークンが無効です。<br>編集は破棄されました。</div>";
    }
}
?>
<h2>ユーザーの一覧</h2>
<?php
$token = $wakarana->create_one_time_token($user_id);

$list = $wakarana->get_all_users(0,500);
$kosu = count($list);
?>
<form method="post" action="manage_user.php" name="delete_form">
<?php
    print "<input type='hidden' name='token' value='".$token."'>";
?>
    <input type="hidden" name="delete" value=" ">
    <input type="hidden" name="user_id" id="delete_user_id" value="">
</form>
<form method="post" action="manage_user.php" name="status_form">
<?php
    print "<input type='hidden' name='token' value='".$token."'>";
?>
    <input type="hidden" name="status" value=" ">
    <input type="hidden" name="user_id" id="status_user_id" value="">
</form>
<script type="text/javascript">
    function delete_kakunin(user_id){
        if(confirm("ユーザー " + user_id + " を削除します。\nよろしいですか？")){
            document.getElementById("delete_user_id").value = user_id;
            document.delete_form.submit();
        }
    }
    
    function status_submit(user_id){
        document.getElementById("status_user_id").value = user_id;
        document.status_form.submit();
    }
</script>

<table><tr><th>ID</th><th>ユーザー名</th><th>種類</th><th>状態</th><th>利用開始日</th><th>最終ログイン</th><th></th></tr>
<?php
for($cnt = 0; $cnt < $kosu; $cnt++){
    print "<tr>";
    
    print "<td>".$list[$cnt]["user_id"]."</td>";
    print "<td>".htmlspecialchars($list[$cnt]["user_name"])."</td>";
    if($list[$cnt]["is_master"]){
        print "<td>マスター</td>";
    }else{
        print "<td>制限付き</td>";
    }
    if($list[$cnt]["status"] == WAKARANA_STATUS_NORMAL){
        print "<td>有効</td>";
    }else{
        print "<td>停止</td>";
    }
    print "<td>".substr($list[$cnt]["user_created"],0,10)."</td>";
    print "<td>".substr($list[$cnt]["last_access"],0,10)."</td>";
    
    print "<td>";
    if($list[$cnt]["user_id"] !== $user_id){
        print "<button type='button' onclick='location.href=\"author_data.php?user_id=".$list[$cnt]["user_id"]."\"'>編集</button>";
        if($list[$cnt]["status"] == WAKARANA_STATUS_NORMAL){
            print " <button type='button' onclick='status_submit(\"".$list[$cnt]["user_id"]."\");'>停止</button>";
        }else{
            print " <button type='button' onclick='status_submit(\"".$list[$cnt]["user_id"]."\");'>有効</button>";
        }
        print " <button type='button' onclick='delete_kakunin(\"".$list[$cnt]["user_id"]."\");'>削除</button>";
    }else{
        print "(自分)";
    }
    print "</td>";
    
    print "</tr>";
}
?>
</table>

<h2>ユーザーの追加</h2>
<form method="post" action="manage_user.php">
<?php
print "<input type='hidden' name='token' value='".$token."'>";
?>
ユーザーID <input type="text" name="user_id" style="width: 300px;"><br>
ユーザー名 <input type="text" name="user_name" style="width: 300px;"><br>
パスワード <input type="password" name="password" style="width: 300px;"><br>
権限の種類 <input type="radio" name="is_master" value="yes">マスター　<input type="radio" name="is_master" value="no" checked="checked">制限付き<br>
<br>
<button type="submit" name="create" value=" ">追加</button>
</form>

<br><br>
            <a href="main.php">&lt;&lt;コントロールパネルTOP</a><br>
                </div>
                <div id="side">
                    <?php include "side.php"; ?>
                </div>
<?php footer_include(); ?>
    </body>
</html><!--Powered by Open本紀-->