<?php
include "../common/main.php";

include "../lib/wakarana/main.php";

$wakarana = new wakarana();
$user_id = $wakarana->check("master");
if($user_id == FALSE){
    header("Location: index.php?go_to=".urlencode(basename($_SERVER['PHP_SELF'])));
    exit(0);
}
$user_info = $wakarana->get_user_info($user_id,FALSE);

header("X-Frame-Options: SAMEORIGIN");

$ini_not_saved = FALSE;
$r_text = "";

if(isset($_POST["title"]) && isset($_POST["subtitle"]) && isset($_POST["info_page"]) && isset($_POST["footer_text"]) && isset($_POST["head_code"])){
    $setting_naiyo = "title=\"".htmlspecialchars($_POST["title"])."\"\nsubtitle=\"".htmlspecialchars($_POST["subtitle"])."\"\nheader_image=\"".htmlspecialchars($_POST["header_image"])."\"\ninfo_page=\"".htmlspecialchars($_POST["info_page"])."\"\nfooter_text=\"".str_replace("\"","\\\"",$_POST["footer_text"])."\"\nhead_code=\"".str_replace("\"","\\\"",$_POST["head_code"])."\"";
    if(isset($_POST["token"]) && $wakarana->check_one_time_token($user_id,$_POST["token"])){
        file_put_contents("../config/setting.ini",$setting_naiyo);
        
        $r_text = "<span style='font-size: x-large;'>変更を保存しました。</span><br>";
        
        $setting = parse_ini_string($setting_naiyo);
    }else{
        $r_text = "<div style='color: #ff0000; font-weight: bold; background-color: #ffcccc; padding: 16px;'>ワンタイムトークンが無効です。<br>フォームの内容を再送信してください。</div>";
        
        $ini_not_saved = TRUE;
    }
}
?><!DOCTYPE html>
<html>
    <head>
<?php head_include();
print "<title>基本情報設定 | ".$setting["title"]."</title>";
?>
        <script type="text/javascript" src="owner.js"></script>
        <link rel="stylesheet" href="owner.css" type="text/css">
    </head>
    <body>
<?php header_include(); ?>
                <div id="content">
<h1>基本情報設定</h1>
ブログのタイトルや、ヘッダー画像の変更を行います。<br><br>
<?php
if($ini_not_saved){
    $setting = parse_ini_string($setting_naiyo);
}
print $r_text;
?>
<form action="setting.php" method="post">

<h3>ブログのタイトル：</h3>
このブログのメインタイトルを設定してください。<br>
<?php
print "<input type='text' name='title' value='".htmlspecialchars($setting["title"])."' style='font-size: x-large; width: 400px;'>";
?>
<h3>サブタイトル：</h3>
メインタイトルの下に表示されるサブタイトルです。<br>
<?php
print "<input type='text' name='subtitle' value='".htmlspecialchars($setting["subtitle"])."' style='width: 400px;'>";
?>
<h3>ヘッダー画像の変更</h3>
各ページのヘッダー画像を変更できます。<br>
なお、トップページのヘッダー画像の変更は<a href="top.php">トップページの設定</a>から行えます。
<h4>画像ファイルのパス：</h4>
<?php
print "<input type='text' name='header_image' value='".htmlspecialchars($setting["header_image"])."' id='header_image' style='width: 300px;'>";
?>
 <button type="button" onclick="image_sansho(false,'header_image');">参照</button><br><br>
<div id="image_kakunin"></div>
<script type="text/javascript">
    function image_kakunin(){
        var image_id_val = document.getElementById("header_image").value;
        var image_kakunin_box = document.getElementById("image_kakunin");
        if(image_id_val.length > 0){
            image_kakunin_box.innerHTML = "<img src='" + image_id_val + "' alt='' style='width: 600px;'>";
        }else{
            image_kakunin_box.innerHTML = "";
        }
    }
    
    window.addEventListener("load",image_kakunin);
</script>
<br>
※使用する画像の縦横比は 横:縦=8:1 としてください。(一部テンプレートを除く)<br>
※表示速度の観点から、ファイルサイズは100KB以下が理想的です。<br>
※空欄の場合はデフォルトの画像にセットされます。<br>

<h3>インフォメーションページ</h3>
ブログについての説明を記述した記事のページをURLで指定してください。<br>
<?php
print "<input type='text' name='info_page' value='".htmlspecialchars($setting["info_page"])."' style='width: 350px;'>";
?>
<h3>フッターテキスト</h3>
ページの最下部に表示されるテキストです。<br>
記事のライセンス情報などの短文を入力してください。<br>
<?php
print "<textarea name='footer_text' style='width: 95%; height: 100px;'>".htmlspecialchars($setting["footer_text"])."</textarea>";
print "<script src='".$dir_path."lib/hongi_editor_2/main.js'></script>";
?>
<script type="text/javascript">
    hongi_editor_include("footer_text");
    hongi_editor_set_browse_image_function("image_sansho_hongi_editor");
</script>
<h3>HEAD内HTML</h3>
HEADタグの末尾ににHTMLコードを追加できます。スタイルシートやアクセス解析コードの追加に利用できます。<br>
<?php
print "<textarea name='head_code' style='width: 95%; height: 150px;'>".htmlspecialchars($setting["head_code"])."</textarea><br><br>";

print "<input type='hidden' name='token' value='".$wakarana->create_one_time_token($user_id)."'>";
?>
<button type="submit">編集確定</button>
</form>
            <br>
            <br>
            <a href="main.php">&lt;&lt;コントロールパネルTOP</a><br>
                </div>
                <div id="side">
                    <?php include "side.php"; ?>
                </div>
<?php footer_include(); ?>
    </body>
</html><!--Powered by Open本紀-->