<?php
include "../common/main.php";

include "../lib/wakarana/main.php";

$wakarana = new wakarana();
$user_id = $wakarana->check("master");
if($user_id == FALSE){
    header("Location: index.php?go_to=".urlencode(basename($_SERVER['PHP_SELF'])));
    exit(0);
}
$user_info = $wakarana->get_user_info($user_id,FALSE);

header("X-Frame-Options: SAMEORIGIN");
?><!DOCTYPE html>
<html>
    <head>
<?php head_include();
print "<title>トップページの設定 | ".$setting["title"]."</title>";
?>
        <script type="text/javascript" src="owner.js"></script>
        <link rel="stylesheet" href="owner.css" type="text/css">
    </head>
    <body>
<?php header_include(); ?>
                <div id="content">
<h1>トップページの設定</h1>
<?php
$top = parse_ini_file("../config/top.ini");
$top_authors = parse_ini_file("../config/top_authors.ini");

if(isset($_POST["header_path"],$_POST["top_html"],$_POST["side_html"],$_POST["bottom_html"])){
    $style_data = parse_ini_file("../style/style_data.ini");
    
    if(strlen($_POST["header_path"]) >= 1){
        $header_path = $_POST["header_path"];
    }else{
        $header_path = $dir_path."style/".$style_data["top_header"];
    }
    
    if(isset($_POST["title_visibility"])){
        $title_visibility = "true";
    }else{
        $title_visibility = "false";
    }
    
    
    $top_authors_ini = "";
    $top_authors_html = "";
    
    if(!empty($_POST["top_authors"])){
        for($cnt = 0; isset($_POST["top_authors"][$cnt]); $cnt++){
            $top_authors_ini = $top_authors_ini."user_id[".$cnt."]=\"".$_POST["top_authors"][$cnt]."\"\n";
        }
        
        $top_authors = parse_ini_string($top_authors_ini);
    }else{
        $top_authors = array();
    }
    
    
    $top_naiyo = "header_path=\"".$header_path."\"\ntitle_visibility=".$title_visibility."\ntop_html=\"".str_replace("\"","\\\"",str_replace("\\","\\\\",$_POST["top_html"]))."\"\nside_html=\"".str_replace("\"","\\\"",str_replace("\\","\\\\",$_POST["side_html"]))."\"\nbottom_html=\"".str_replace("\"","\\\"",str_replace("\\","\\\\",$_POST["bottom_html"]))."\"";
    if(isset($_POST["token"]) && $wakarana->check_one_time_token($user_id,$_POST["token"])){
        
        file_put_contents("../config/top.ini",$top_naiyo);
        file_put_contents("../config/top_authors.ini",$top_authors_ini);
        
        include "../modules/authors.php";
        $authors = new open_hongi_authors();
        
        $authors->update_top_html();
        
        print "<span style='font-size: x-large;'>変更を保存しました。</span><br><br>";
    }else{
        print "<div style='color: #ff0000; font-weight: bold; background-color: #ffcccc; padding: 16px;'>ワンタイムトークンが無効です。<br>フォームの内容を再送信してください。</div>";
    }
    
    $top = parse_ini_string($top_naiyo);
}
?>
<script type='text/javascript' src='../lib/hongi_editor_2/main.js'></script>
<script type="text/javascript">
    hongi_editor_set_browse_image_function("image_sansho_hongi_editor");
</script>

<form action='top.php' method='post'>
<h3>ヘッダー画像</h3>
トップページ用ヘッダー画像のパスを入力してください。<br>
空欄の場合はデフォルトの画像にセットされます。<br>
<?php
print "<input name='header_path' id='header_path' style='width: 300px;' value='".htmlspecialchars($top["header_path"])."'> <button type='button' onclick='image_sansho(false,\"header_path\");'>参照</button><br><br>";
?>
<div id="image_kakunin"></div>
<script type="text/javascript">
    function image_kakunin(){
        var image_id_val = document.getElementById("header_path").value;
        var image_kakunin_box = document.getElementById("image_kakunin");
        if(image_id_val.length > 0){
            image_kakunin_box.innerHTML = "<img src='" + image_id_val + "' alt='' style='width: 600px;'>";
        }else{
            image_kakunin_box.innerHTML = "";
        }
    }
    
    window.addEventListener("load",image_kakunin);
</script>

<h3>任意HTML領域の編集</h3>
トップページの各部に、自由にHTMLを設定することができます。<br>ブログの簡単な紹介や広告、相互リンクなどに活用できます。<br>

<h4>上部領域(お知らせ欄の上)：</h4>
<?php
print "<textarea name='top_html' style='width: 95%; height: 200px;'>".htmlspecialchars($top["top_html"])."</textarea>";
?>
<script type='text/javascript'>hongi_editor_include('top_html');</script>

<h4>左メニュー領域(カレンダーの下)：</h4>
<?php
print "<textarea name='side_html' style='width: 180px; height: 300px;'>".htmlspecialchars($top["side_html"])."</textarea>";
?>
<script type='text/javascript'>hongi_editor_include('side_html');</script>

<h4>下部領域(最近の画像の下)：</h4>
<?php
print "<textarea name='bottom_html' style='width: 95%; height: 200px;'>".htmlspecialchars($top["bottom_html"])."</textarea>";
?>
<script type='text/javascript'>hongi_editor_include('bottom_html');</script>

<h3>タイトル文字の表示</h3>
<?php
if($top["title_visibility"]){
    print "<input type='checkbox' value='1' name='title_visibility' checked='checked'> タイトル文字を表示<br>";
}else{
    print "<input type='checkbox' value='1' name='title_visibility'> タイトル文字を表示<br>";
}
?>
ヘッダー画像そのものにロゴが含まれている場合は、タイトル文字を非表示にします。<br><br>

<h3>トップページに表示する著者</h3>
トップページサイドバーに表示する著者を選択してください。(複数選択可)<br>
<select name="top_authors[]" style="width: 200px; height: 300px;" multiple>
<?php
$user_list = $wakarana->get_all_users();

$u_kensu = count($user_list);
for($u_cnt = 0; $u_cnt < $u_kensu; $u_cnt++){
    if(isset($top_authors["user_id"]) && in_array($user_list[$u_cnt]["user_id"],$top_authors["user_id"])){
        print "<option value='".$user_list[$u_cnt]["user_id"]."' selected>".$user_list[$u_cnt]["user_name"]."</option>";
    }else{
        print "<option value='".$user_list[$u_cnt]["user_id"]."'>".$user_list[$u_cnt]["user_name"]."</option>";
    }
}
?>
</select><br>
<br><br>
<?php
print "<input type='hidden' name='token' value='".$wakarana->create_one_time_token($user_id)."'>";
?>
<button type='submit' style='font-size: x-large;'>編集確定</button>
</form>
            <br>
            <br>
            <a href="main.php">&lt;&lt;コントロールパネルTOP</a><br>
                </div>
                <div id="side">
                    <?php include "side.php"; ?>
                </div>
<?php footer_include(); ?>
    </body>
</html><!--Powered by Open本紀-->